/* board.c generated by valac 0.56.3, the Vala compiler
 * generated from board.vala, do not modify */

/*
 * Color lines for GNOME
 * Copyright © 1999 Free Software Foundation
 * Authors: Robert Szokovacs <szo@szo.hu>
 *          Szabolcs Ban <shooby@gnome.hu>
 *          Karuna Grewal <karunagrewal98@gmail.com>
 *          Ruxandra Simion <ruxandra.simion93@gmail.com>
 * Copyright © 2007 Christian Persch
 *
 * This game is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <https://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gee.h>
#include <glib.h>
#include <stdlib.h>
#include <gobject/gvaluecollector.h>

#define GAME_N_MATCH 5
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_BOARD (board_get_type ())
#define BOARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOARD, Board))
#define BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOARD, BoardClass))
#define IS_BOARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOARD))
#define IS_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOARD))
#define BOARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOARD, BoardClass))

typedef struct _Board Board;
typedef struct _BoardClass BoardClass;
typedef struct _BoardPrivate BoardPrivate;

#define TYPE_CELL (cell_get_type ())
#define CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CELL, Cell))
#define CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CELL, CellClass))
#define IS_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CELL))
#define IS_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CELL))
#define CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CELL, CellClass))

typedef struct _Cell Cell;
typedef struct _CellClass CellClass;
#define _cell_unref0(var) ((var == NULL) ? NULL : (var = (cell_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_PIECE (piece_get_type ())
#define PIECE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIECE, Piece))
#define PIECE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIECE, PieceClass))
#define IS_PIECE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIECE))
#define IS_PIECE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIECE))
#define PIECE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIECE, PieceClass))

typedef struct _Piece Piece;
typedef struct _PieceClass PieceClass;
typedef struct _CellPrivate CellPrivate;
#define _piece_unref0(var) ((var == NULL) ? NULL : (var = (piece_unref (var), NULL)))
typedef struct _ParamSpecBoard ParamSpecBoard;
enum  {
	BOARD_GRID_CHANGED_SIGNAL,
	BOARD_BOARD_CHANGED_SIGNAL,
	BOARD_NUM_SIGNALS
};
static guint board_signals[BOARD_NUM_SIGNALS] = {0};
typedef enum  {
	DIRECTION_RIGHT,
	DIRECTION_LEFT,
	DIRECTION_UP,
	DIRECTION_DOWN,
	DIRECTION_UPPER_RIGHT,
	DIRECTION_LOWER_LEFT,
	DIRECTION_UPPER_LEFT,
	DIRECTION_LOWER_RIGHT
} Direction;

#define TYPE_DIRECTION (direction_get_type ())
typedef struct _ParamSpecCell ParamSpecCell;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Board {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BoardPrivate * priv;
	GeeArrayList* closed;
	GeeArrayList* path;
};

struct _BoardClass {
	GTypeClass parent_class;
	void (*finalize) (Board *self);
};

struct _BoardPrivate {
	Cell** grid;
	gint grid_length1;
	gint grid_length2;
	Cell* src;
	Cell* dst;
	GeeArrayList* open;
};

struct _Cell {
	GTypeInstance parent_instance;
	volatile int ref_count;
	CellPrivate * priv;
	gint row;
	gint col;
	Cell* parent;
	Piece* piece;
	gint cost;
};

struct _CellClass {
	GTypeClass parent_class;
	void (*finalize) (Cell *self);
};

struct _ParamSpecBoard {
	GParamSpec parent_instance;
};

struct _ParamSpecCell {
	GParamSpec parent_instance;
};

static gint Board_private_offset;
static gpointer board_parent_class = NULL;
static gpointer cell_parent_class = NULL;

VALA_EXTERN gpointer board_ref (gpointer instance);
VALA_EXTERN void board_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_board (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags);
VALA_EXTERN void value_set_board (GValue* value,
                      gpointer v_object);
VALA_EXTERN void value_take_board (GValue* value,
                       gpointer v_object);
VALA_EXTERN gpointer value_get_board (const GValue* value);
VALA_EXTERN GType board_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Board, board_unref)
VALA_EXTERN gpointer cell_ref (gpointer instance);
VALA_EXTERN void cell_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_cell (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags);
VALA_EXTERN void value_set_cell (GValue* value,
                     gpointer v_object);
VALA_EXTERN void value_take_cell (GValue* value,
                      gpointer v_object);
VALA_EXTERN gpointer value_get_cell (const GValue* value);
VALA_EXTERN GType cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Cell, cell_unref)
VALA_EXTERN Board* board_new (gint n_rows,
                  gint n_cols);
VALA_EXTERN Board* board_construct (GType object_type,
                        gint n_rows,
                        gint n_cols);
VALA_EXTERN gpointer piece_ref (gpointer instance);
VALA_EXTERN void piece_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_piece (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags);
VALA_EXTERN void value_set_piece (GValue* value,
                      gpointer v_object);
VALA_EXTERN void value_take_piece (GValue* value,
                       gpointer v_object);
VALA_EXTERN gpointer value_get_piece (const GValue* value);
VALA_EXTERN GType piece_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Piece, piece_unref)
VALA_EXTERN Cell* cell_new (gint row,
                gint col,
                Cell* parent,
                Piece* piece);
VALA_EXTERN Cell* cell_construct (GType object_type,
                      gint row,
                      gint col,
                      Cell* parent,
                      Piece* piece);
VALA_EXTERN void board_reset (Board* self,
                  gint n_rows,
                  gint n_cols);
VALA_EXTERN Cell** board_get_grid (Board* self,
                       gint* result_length1,
                       gint* result_length2);
static Cell** _vala_array_dup1 (Cell** self,
                         gssize length);
VALA_EXTERN void board_set_piece (Board* self,
                      gint row,
                      gint col,
                      Piece* piece);
VALA_EXTERN Piece* board_get_piece (Board* self,
                        gint row,
                        gint col);
VALA_EXTERN Cell* board_get_cell (Board* self,
                      gint row,
                      gint col);
VALA_EXTERN GeeArrayList* board_find_path (Board* self,
                               gint start_row,
                               gint start_col,
                               gint end_row,
                               gint end_col);
static void board_reset_path_search (Board* self);
static gboolean board_cell_equal (Board* self,
                           Cell* a,
                           Cell* b);
static gboolean _board_cell_equal_gee_equal_data_func (gconstpointer a,
                                                gconstpointer b,
                                                gpointer self);
static Cell* board_best_candidate (Board* self,
                            GeeArrayList* neighbours,
                            gint current_cost,
                            Cell* end);
VALA_EXTERN GeeArrayList* cell_get_neighbours (Cell* self,
                                   Cell** board,
                                   gint board_length1,
                                   gint board_length2);
static gint board_total_cost (Board* self,
                       Cell* start,
                       Cell* end,
                       gint current_cost);
VALA_EXTERN gboolean cell_equal (Cell* self,
                     Cell* cell);
static gint board_manhattan (Board* self,
                      gint start_x,
                      gint start_y,
                      gint end_x,
                      gint end_y);
VALA_EXTERN gint board_get_n_rows (Board* self);
VALA_EXTERN gint board_get_n_cols (Board* self);
static void board_finalize (Board * obj);
static GType board_get_type_once (void);
VALA_EXTERN GType direction_get_type (void) G_GNUC_CONST ;
static Cell* cell_get_neighbour (Cell* self,
                          Cell** board,
                          gint board_length1,
                          gint board_length2,
                          Direction dir);
static void cell_get_direction (Cell* self,
                         Cell** board,
                         gint board_length1,
                         gint board_length2,
                         Direction dir,
                         GeeArrayList** list);
VALA_EXTERN gboolean piece_equal (Piece* self,
                      Piece* piece);
static GeeArrayList* cell_get_horizontal (Cell* self,
                                   Cell** board,
                                   gint board_length1,
                                   gint board_length2);
static GeeArrayList* cell_get_vertical (Cell* self,
                                 Cell** board,
                                 gint board_length1,
                                 gint board_length2);
static GeeArrayList* cell_get_first_diagonal (Cell* self,
                                       Cell** board,
                                       gint board_length1,
                                       gint board_length2);
static GeeArrayList* cell_get_second_diagonal (Cell* self,
                                        Cell** board,
                                        gint board_length1,
                                        gint board_length2);
VALA_EXTERN GeeHashSet* cell_get_all_directions (Cell* self,
                                     Cell** board,
                                     gint board_length1,
                                     gint board_length2);
static void cell_finalize (Cell * obj);
static GType cell_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
board_get_instance_private (Board* self)
{
	return G_STRUCT_MEMBER_P (self, Board_private_offset);
}

Board*
board_construct (GType object_type,
                 gint n_rows,
                 gint n_cols)
{
	Board* self = NULL;
	Cell** _tmp0_;
#line 52 "../src/board.vala"
	self = (Board*) g_type_create_instance (object_type);
#line 54 "../src/board.vala"
	_tmp0_ = g_new0 (Cell*, (n_rows * n_cols) + 1);
#line 54 "../src/board.vala"
	self->priv->grid = (_vala_array_free (self->priv->grid, self->priv->grid_length1 * self->priv->grid_length2, (GDestroyNotify) cell_unref), NULL);
#line 54 "../src/board.vala"
	self->priv->grid = _tmp0_;
#line 54 "../src/board.vala"
	self->priv->grid_length1 = n_rows;
#line 54 "../src/board.vala"
	self->priv->grid_length2 = n_cols;
#line 331 "board.c"
	{
		gint col = 0;
#line 55 "../src/board.vala"
		col = 0;
#line 336 "board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 55 "../src/board.vala"
			_tmp1_ = TRUE;
#line 55 "../src/board.vala"
			while (TRUE) {
#line 55 "../src/board.vala"
				if (!_tmp1_) {
#line 345 "board.c"
					gint _tmp2_;
#line 55 "../src/board.vala"
					_tmp2_ = col;
#line 55 "../src/board.vala"
					col = _tmp2_ + 1;
#line 351 "board.c"
				}
#line 55 "../src/board.vala"
				_tmp1_ = FALSE;
#line 55 "../src/board.vala"
				if (!(col < n_cols)) {
#line 55 "../src/board.vala"
					break;
#line 359 "board.c"
				}
				{
					gint row = 0;
#line 57 "../src/board.vala"
					row = 0;
#line 365 "board.c"
					{
						gboolean _tmp3_ = FALSE;
#line 57 "../src/board.vala"
						_tmp3_ = TRUE;
#line 57 "../src/board.vala"
						while (TRUE) {
#line 372 "board.c"
							Cell** _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
							Cell* _tmp6_;
#line 57 "../src/board.vala"
							if (!_tmp3_) {
#line 379 "board.c"
								gint _tmp4_;
#line 57 "../src/board.vala"
								_tmp4_ = row;
#line 57 "../src/board.vala"
								row = _tmp4_ + 1;
#line 385 "board.c"
							}
#line 57 "../src/board.vala"
							_tmp3_ = FALSE;
#line 57 "../src/board.vala"
							if (!(row < n_rows)) {
#line 57 "../src/board.vala"
								break;
#line 393 "board.c"
							}
#line 59 "../src/board.vala"
							_tmp5_ = self->priv->grid;
#line 59 "../src/board.vala"
							_tmp5__length1 = self->priv->grid_length1;
#line 59 "../src/board.vala"
							_tmp5__length2 = self->priv->grid_length2;
#line 59 "../src/board.vala"
							_tmp6_ = cell_new (row, col, NULL, NULL);
#line 59 "../src/board.vala"
							_cell_unref0 (_tmp5_[(row * _tmp5__length2) + col]);
#line 59 "../src/board.vala"
							_tmp5_[(row * _tmp5__length2) + col] = _tmp6_;
#line 407 "board.c"
						}
					}
				}
			}
		}
	}
#line 52 "../src/board.vala"
	return self;
#line 416 "board.c"
}

Board*
board_new (gint n_rows,
           gint n_cols)
{
#line 52 "../src/board.vala"
	return board_construct (TYPE_BOARD, n_rows, n_cols);
#line 425 "board.c"
}

void
board_reset (Board* self,
             gint n_rows,
             gint n_cols)
{
	Cell** _tmp0_;
#line 64 "../src/board.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/board.vala"
	_tmp0_ = g_new0 (Cell*, (n_rows * n_cols) + 1);
#line 66 "../src/board.vala"
	self->priv->grid = (_vala_array_free (self->priv->grid, self->priv->grid_length1 * self->priv->grid_length2, (GDestroyNotify) cell_unref), NULL);
#line 66 "../src/board.vala"
	self->priv->grid = _tmp0_;
#line 66 "../src/board.vala"
	self->priv->grid_length1 = n_rows;
#line 66 "../src/board.vala"
	self->priv->grid_length2 = n_cols;
#line 446 "board.c"
	{
		gint col = 0;
#line 68 "../src/board.vala"
		col = 0;
#line 451 "board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 68 "../src/board.vala"
			_tmp1_ = TRUE;
#line 68 "../src/board.vala"
			while (TRUE) {
#line 68 "../src/board.vala"
				if (!_tmp1_) {
#line 460 "board.c"
					gint _tmp2_;
#line 68 "../src/board.vala"
					_tmp2_ = col;
#line 68 "../src/board.vala"
					col = _tmp2_ + 1;
#line 466 "board.c"
				}
#line 68 "../src/board.vala"
				_tmp1_ = FALSE;
#line 68 "../src/board.vala"
				if (!(col < n_cols)) {
#line 68 "../src/board.vala"
					break;
#line 474 "board.c"
				}
				{
					gint row = 0;
#line 70 "../src/board.vala"
					row = 0;
#line 480 "board.c"
					{
						gboolean _tmp3_ = FALSE;
#line 70 "../src/board.vala"
						_tmp3_ = TRUE;
#line 70 "../src/board.vala"
						while (TRUE) {
#line 487 "board.c"
							Cell** _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
							Cell* _tmp6_;
#line 70 "../src/board.vala"
							if (!_tmp3_) {
#line 494 "board.c"
								gint _tmp4_;
#line 70 "../src/board.vala"
								_tmp4_ = row;
#line 70 "../src/board.vala"
								row = _tmp4_ + 1;
#line 500 "board.c"
							}
#line 70 "../src/board.vala"
							_tmp3_ = FALSE;
#line 70 "../src/board.vala"
							if (!(row < n_rows)) {
#line 70 "../src/board.vala"
								break;
#line 508 "board.c"
							}
#line 72 "../src/board.vala"
							_tmp5_ = self->priv->grid;
#line 72 "../src/board.vala"
							_tmp5__length1 = self->priv->grid_length1;
#line 72 "../src/board.vala"
							_tmp5__length2 = self->priv->grid_length2;
#line 72 "../src/board.vala"
							_tmp6_ = _tmp5_[(row * _tmp5__length2) + col];
#line 72 "../src/board.vala"
							if (_tmp6_ != NULL) {
#line 520 "board.c"
								Cell** _tmp7_;
								gint _tmp7__length1;
								gint _tmp7__length2;
								Cell* _tmp8_;
								Cell** _tmp9_;
								gint _tmp9__length1;
								gint _tmp9__length2;
								Cell* _tmp10_;
								Cell** _tmp11_;
								gint _tmp11__length1;
								gint _tmp11__length2;
								Cell* _tmp12_;
#line 74 "../src/board.vala"
								_tmp7_ = self->priv->grid;
#line 74 "../src/board.vala"
								_tmp7__length1 = self->priv->grid_length1;
#line 74 "../src/board.vala"
								_tmp7__length2 = self->priv->grid_length2;
#line 74 "../src/board.vala"
								_tmp8_ = _tmp7_[(row * _tmp7__length2) + col];
#line 74 "../src/board.vala"
								_cell_unref0 (_tmp8_->parent);
#line 74 "../src/board.vala"
								_tmp8_->parent = NULL;
#line 75 "../src/board.vala"
								_tmp9_ = self->priv->grid;
#line 75 "../src/board.vala"
								_tmp9__length1 = self->priv->grid_length1;
#line 75 "../src/board.vala"
								_tmp9__length2 = self->priv->grid_length2;
#line 75 "../src/board.vala"
								_tmp10_ = _tmp9_[(row * _tmp9__length2) + col];
#line 75 "../src/board.vala"
								_piece_unref0 (_tmp10_->piece);
#line 75 "../src/board.vala"
								_tmp10_->piece = NULL;
#line 76 "../src/board.vala"
								_tmp11_ = self->priv->grid;
#line 76 "../src/board.vala"
								_tmp11__length1 = self->priv->grid_length1;
#line 76 "../src/board.vala"
								_tmp11__length2 = self->priv->grid_length2;
#line 76 "../src/board.vala"
								_tmp12_ = _tmp11_[(row * _tmp11__length2) + col];
#line 76 "../src/board.vala"
								_tmp12_->cost = G_MAXINT;
#line 567 "board.c"
							} else {
								Cell** _tmp13_;
								gint _tmp13__length1;
								gint _tmp13__length2;
								Cell* _tmp14_;
#line 79 "../src/board.vala"
								_tmp13_ = self->priv->grid;
#line 79 "../src/board.vala"
								_tmp13__length1 = self->priv->grid_length1;
#line 79 "../src/board.vala"
								_tmp13__length2 = self->priv->grid_length2;
#line 79 "../src/board.vala"
								_tmp14_ = cell_new (row, col, NULL, NULL);
#line 79 "../src/board.vala"
								_cell_unref0 (_tmp13_[(row * _tmp13__length2) + col]);
#line 79 "../src/board.vala"
								_tmp13_[(row * _tmp13__length2) + col] = _tmp14_;
#line 585 "board.c"
							}
						}
					}
				}
			}
		}
	}
#line 83 "../src/board.vala"
	g_signal_emit (self, board_signals[BOARD_BOARD_CHANGED_SIGNAL], 0);
#line 595 "board.c"
}

static gpointer
_cell_ref0 (gpointer self)
{
#line 88 "../src/board.vala"
	return self ? cell_ref (self) : NULL;
#line 603 "board.c"
}

static Cell**
_vala_array_dup1 (Cell** self,
                  gssize length)
{
#line 88 "../src/board.vala"
	if (length >= 0) {
#line 612 "board.c"
		Cell** result;
		gssize i;
#line 88 "../src/board.vala"
		result = g_new0 (Cell*, length + 1);
#line 88 "../src/board.vala"
		for (i = 0; i < length; i++) {
#line 619 "board.c"
			Cell* _tmp0_;
#line 88 "../src/board.vala"
			_tmp0_ = _cell_ref0 (self[i]);
#line 88 "../src/board.vala"
			result[i] = _tmp0_;
#line 625 "board.c"
		}
#line 88 "../src/board.vala"
		return result;
#line 629 "board.c"
	}
#line 88 "../src/board.vala"
	return NULL;
#line 633 "board.c"
}

Cell**
board_get_grid (Board* self,
                gint* result_length1,
                gint* result_length2)
{
	Cell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Cell** _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	Cell** _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	Cell** result;
#line 86 "../src/board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 88 "../src/board.vala"
	_tmp0_ = self->priv->grid;
#line 88 "../src/board.vala"
	_tmp0__length1 = self->priv->grid_length1;
#line 88 "../src/board.vala"
	_tmp0__length2 = self->priv->grid_length2;
#line 88 "../src/board.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup1 (_tmp0_, _tmp0__length1 * _tmp0__length2) : _tmp0_;
#line 88 "../src/board.vala"
	_tmp1__length1 = _tmp0__length1;
#line 88 "../src/board.vala"
	_tmp1__length2 = _tmp0__length2;
#line 88 "../src/board.vala"
	_tmp2_ = _tmp1_;
#line 88 "../src/board.vala"
	_tmp2__length1 = _tmp1__length1;
#line 88 "../src/board.vala"
	_tmp2__length2 = _tmp1__length2;
#line 88 "../src/board.vala"
	if (result_length1) {
#line 88 "../src/board.vala"
		*result_length1 = _tmp2__length1;
#line 675 "board.c"
	}
#line 88 "../src/board.vala"
	if (result_length2) {
#line 88 "../src/board.vala"
		*result_length2 = _tmp2__length2;
#line 681 "board.c"
	}
#line 88 "../src/board.vala"
	result = _tmp2_;
#line 88 "../src/board.vala"
	return result;
#line 687 "board.c"
}

static gpointer
_piece_ref0 (gpointer self)
{
#line 93 "../src/board.vala"
	return self ? piece_ref (self) : NULL;
#line 695 "board.c"
}

void
board_set_piece (Board* self,
                 gint row,
                 gint col,
                 Piece* piece)
{
	Cell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Cell* _tmp1_;
	Piece* _tmp2_;
#line 91 "../src/board.vala"
	g_return_if_fail (self != NULL);
#line 93 "../src/board.vala"
	_tmp0_ = self->priv->grid;
#line 93 "../src/board.vala"
	_tmp0__length1 = self->priv->grid_length1;
#line 93 "../src/board.vala"
	_tmp0__length2 = self->priv->grid_length2;
#line 93 "../src/board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 93 "../src/board.vala"
	_tmp2_ = _piece_ref0 (piece);
#line 93 "../src/board.vala"
	_piece_unref0 (_tmp1_->piece);
#line 93 "../src/board.vala"
	_tmp1_->piece = _tmp2_;
#line 725 "board.c"
}

Piece*
board_get_piece (Board* self,
                 gint row,
                 gint col)
{
	Cell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Cell* _tmp1_;
	Piece* _tmp2_;
	Piece* _tmp3_;
	Piece* result;
#line 96 "../src/board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 98 "../src/board.vala"
	_tmp0_ = self->priv->grid;
#line 98 "../src/board.vala"
	_tmp0__length1 = self->priv->grid_length1;
#line 98 "../src/board.vala"
	_tmp0__length2 = self->priv->grid_length2;
#line 98 "../src/board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 98 "../src/board.vala"
	_tmp2_ = _tmp1_->piece;
#line 98 "../src/board.vala"
	_tmp3_ = _piece_ref0 (_tmp2_);
#line 98 "../src/board.vala"
	result = _tmp3_;
#line 98 "../src/board.vala"
	return result;
#line 758 "board.c"
}

Cell*
board_get_cell (Board* self,
                gint row,
                gint col)
{
	Cell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Cell* _tmp1_;
	Cell* _tmp2_;
	Cell* result;
#line 101 "../src/board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 103 "../src/board.vala"
	_tmp0_ = self->priv->grid;
#line 103 "../src/board.vala"
	_tmp0__length1 = self->priv->grid_length1;
#line 103 "../src/board.vala"
	_tmp0__length2 = self->priv->grid_length2;
#line 103 "../src/board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 103 "../src/board.vala"
	_tmp2_ = _cell_ref0 (_tmp1_);
#line 103 "../src/board.vala"
	result = _tmp2_;
#line 103 "../src/board.vala"
	return result;
#line 788 "board.c"
}

static gboolean
_board_cell_equal_gee_equal_data_func (gconstpointer a,
                                       gconstpointer b,
                                       gpointer self)
{
	gboolean result;
	result = board_cell_equal ((Board*) self, (Cell*) a, (Cell*) b);
#line 116 "../src/board.vala"
	return result;
#line 800 "board.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 139 "../src/board.vala"
	return self ? g_object_ref (self) : NULL;
#line 808 "board.c"
}

GeeArrayList*
board_find_path (Board* self,
                 gint start_row,
                 gint start_col,
                 gint end_row,
                 gint end_col)
{
	Cell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Cell* _tmp1_;
	Cell* _tmp2_;
	Cell** _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	Cell* _tmp4_;
	Cell* _tmp5_;
	GeeArrayList* _tmp6_;
	GeeArrayList* _tmp7_;
	GeeArrayList* _tmp8_;
	Cell* _tmp9_;
	Cell* current_cell = NULL;
	gint current_cost = 0;
	GeeArrayList* neighbours = NULL;
	GeeArrayList* _tmp66_;
	GeeArrayList* _tmp67_;
	GeeArrayList* result;
#line 106 "../src/board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 111 "../src/board.vala"
	board_reset_path_search (self);
#line 113 "../src/board.vala"
	_tmp0_ = self->priv->grid;
#line 113 "../src/board.vala"
	_tmp0__length1 = self->priv->grid_length1;
#line 113 "../src/board.vala"
	_tmp0__length2 = self->priv->grid_length2;
#line 113 "../src/board.vala"
	_tmp1_ = _tmp0_[(start_row * _tmp0__length2) + start_col];
#line 113 "../src/board.vala"
	_tmp2_ = _cell_ref0 (_tmp1_);
#line 113 "../src/board.vala"
	_cell_unref0 (self->priv->src);
#line 113 "../src/board.vala"
	self->priv->src = _tmp2_;
#line 114 "../src/board.vala"
	_tmp3_ = self->priv->grid;
#line 114 "../src/board.vala"
	_tmp3__length1 = self->priv->grid_length1;
#line 114 "../src/board.vala"
	_tmp3__length2 = self->priv->grid_length2;
#line 114 "../src/board.vala"
	_tmp4_ = _tmp3_[(end_row * _tmp3__length2) + end_col];
#line 114 "../src/board.vala"
	_tmp5_ = _cell_ref0 (_tmp4_);
#line 114 "../src/board.vala"
	_cell_unref0 (self->priv->dst);
#line 114 "../src/board.vala"
	self->priv->dst = _tmp5_;
#line 116 "../src/board.vala"
	_tmp6_ = gee_array_list_new (TYPE_CELL, (GBoxedCopyFunc) cell_ref, (GDestroyNotify) cell_unref, _board_cell_equal_gee_equal_data_func, board_ref (self), board_unref);
#line 116 "../src/board.vala"
	_g_object_unref0 (self->closed);
#line 116 "../src/board.vala"
	self->closed = _tmp6_;
#line 118 "../src/board.vala"
	_tmp7_ = gee_array_list_new (TYPE_CELL, (GBoxedCopyFunc) cell_ref, (GDestroyNotify) cell_unref, _board_cell_equal_gee_equal_data_func, board_ref (self), board_unref);
#line 118 "../src/board.vala"
	_g_object_unref0 (self->priv->open);
#line 118 "../src/board.vala"
	self->priv->open = _tmp7_;
#line 119 "../src/board.vala"
	_tmp8_ = self->priv->open;
#line 119 "../src/board.vala"
	_tmp9_ = self->priv->src;
#line 119 "../src/board.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp9_);
#line 121 "../src/board.vala"
	current_cell = NULL;
#line 122 "../src/board.vala"
	current_cost = 0;
#line 892 "board.c"
	{
		gboolean _tmp10_ = FALSE;
#line 125 "../src/board.vala"
		_tmp10_ = TRUE;
#line 125 "../src/board.vala"
		while (TRUE) {
#line 899 "board.c"
			GeeArrayList* _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
			GeeArrayList* _tmp17_;
			Cell* _tmp18_;
			Cell* _tmp19_;
			GeeArrayList* _tmp20_;
			Cell* _tmp21_;
			GeeArrayList* _tmp22_;
			Cell* _tmp23_;
			GeeArrayList* _tmp24_;
			Cell* _tmp25_;
			Cell* _tmp37_;
			Cell** _tmp38_;
			gint _tmp38__length1;
			gint _tmp38__length2;
			GeeArrayList* _tmp39_;
#line 125 "../src/board.vala"
			if (!_tmp10_) {
#line 919 "board.c"
				GeeArrayList* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
#line 169 "../src/board.vala"
				_tmp11_ = self->priv->open;
#line 169 "../src/board.vala"
				_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 169 "../src/board.vala"
				_tmp13_ = _tmp12_;
#line 169 "../src/board.vala"
				if (!(_tmp13_ != 0)) {
#line 169 "../src/board.vala"
					break;
#line 933 "board.c"
				}
			}
#line 125 "../src/board.vala"
			_tmp10_ = FALSE;
#line 127 "../src/board.vala"
			_tmp14_ = self->closed;
#line 127 "../src/board.vala"
			_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
#line 127 "../src/board.vala"
			_tmp16_ = _tmp15_;
#line 127 "../src/board.vala"
			current_cost = _tmp16_;
#line 129 "../src/board.vala"
			_tmp17_ = self->priv->open;
#line 129 "../src/board.vala"
			_tmp18_ = self->priv->dst;
#line 129 "../src/board.vala"
			_tmp19_ = board_best_candidate (self, _tmp17_, current_cost, _tmp18_);
#line 129 "../src/board.vala"
			_cell_unref0 (current_cell);
#line 129 "../src/board.vala"
			current_cell = _tmp19_;
#line 130 "../src/board.vala"
			_tmp20_ = self->closed;
#line 130 "../src/board.vala"
			_tmp21_ = current_cell;
#line 130 "../src/board.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
#line 131 "../src/board.vala"
			_tmp22_ = self->priv->open;
#line 131 "../src/board.vala"
			_tmp23_ = current_cell;
#line 131 "../src/board.vala"
			gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp22_, _tmp23_);
#line 133 "../src/board.vala"
			_tmp24_ = self->closed;
#line 133 "../src/board.vala"
			_tmp25_ = self->priv->dst;
#line 133 "../src/board.vala"
			if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp24_, _tmp25_)) {
#line 974 "board.c"
				GeeArrayList* _tmp35_;
				GeeArrayList* _tmp36_;
				{
					Cell* p = NULL;
					Cell* _tmp26_;
					Cell* _tmp27_;
#line 135 "../src/board.vala"
					_tmp26_ = self->priv->dst;
#line 135 "../src/board.vala"
					_tmp27_ = _cell_ref0 (_tmp26_);
#line 135 "../src/board.vala"
					p = _tmp27_;
#line 987 "board.c"
					{
						gboolean _tmp28_ = FALSE;
#line 135 "../src/board.vala"
						_tmp28_ = TRUE;
#line 135 "../src/board.vala"
						while (TRUE) {
#line 994 "board.c"
							Cell* _tmp32_;
							GeeArrayList* _tmp33_;
							Cell* _tmp34_;
#line 135 "../src/board.vala"
							if (!_tmp28_) {
#line 1000 "board.c"
								Cell* _tmp29_;
								Cell* _tmp30_;
								Cell* _tmp31_;
#line 135 "../src/board.vala"
								_tmp29_ = p;
#line 135 "../src/board.vala"
								_tmp30_ = _tmp29_->parent;
#line 135 "../src/board.vala"
								_tmp31_ = _cell_ref0 (_tmp30_);
#line 135 "../src/board.vala"
								_cell_unref0 (p);
#line 135 "../src/board.vala"
								p = _tmp31_;
#line 1014 "board.c"
							}
#line 135 "../src/board.vala"
							_tmp28_ = FALSE;
#line 135 "../src/board.vala"
							_tmp32_ = p;
#line 135 "../src/board.vala"
							if (!(_tmp32_ != NULL)) {
#line 135 "../src/board.vala"
								break;
#line 1024 "board.c"
							}
#line 137 "../src/board.vala"
							_tmp33_ = self->path;
#line 137 "../src/board.vala"
							_tmp34_ = p;
#line 137 "../src/board.vala"
							gee_abstract_list_insert ((GeeAbstractList*) _tmp33_, 0, _tmp34_);
#line 1032 "board.c"
						}
					}
#line 135 "../src/board.vala"
					_cell_unref0 (p);
#line 1037 "board.c"
				}
#line 139 "../src/board.vala"
				_tmp35_ = self->path;
#line 139 "../src/board.vala"
				_tmp36_ = _g_object_ref0 (_tmp35_);
#line 139 "../src/board.vala"
				result = _tmp36_;
#line 139 "../src/board.vala"
				_g_object_unref0 (neighbours);
#line 139 "../src/board.vala"
				_cell_unref0 (current_cell);
#line 139 "../src/board.vala"
				return result;
#line 1051 "board.c"
			}
#line 142 "../src/board.vala"
			_tmp37_ = current_cell;
#line 142 "../src/board.vala"
			_tmp38_ = self->priv->grid;
#line 142 "../src/board.vala"
			_tmp38__length1 = self->priv->grid_length1;
#line 142 "../src/board.vala"
			_tmp38__length2 = self->priv->grid_length2;
#line 142 "../src/board.vala"
			_tmp39_ = cell_get_neighbours (_tmp37_, _tmp38_, (gint) _tmp38__length1, (gint) _tmp38__length2);
#line 142 "../src/board.vala"
			_g_object_unref0 (neighbours);
#line 142 "../src/board.vala"
			neighbours = _tmp39_;
#line 1067 "board.c"
			{
				GeeArrayList* _neighbour_list = NULL;
				GeeArrayList* _tmp40_;
				gint _neighbour_size = 0;
				GeeArrayList* _tmp41_;
				gint _tmp42_;
				gint _tmp43_;
				gint _neighbour_index = 0;
#line 143 "../src/board.vala"
				_tmp40_ = neighbours;
#line 143 "../src/board.vala"
				_neighbour_list = _tmp40_;
#line 143 "../src/board.vala"
				_tmp41_ = _neighbour_list;
#line 143 "../src/board.vala"
				_tmp42_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp41_);
#line 143 "../src/board.vala"
				_tmp43_ = _tmp42_;
#line 143 "../src/board.vala"
				_neighbour_size = _tmp43_;
#line 143 "../src/board.vala"
				_neighbour_index = -1;
#line 143 "../src/board.vala"
				while (TRUE) {
#line 1092 "board.c"
					gint _tmp44_;
					gint _tmp45_;
					Cell* neighbour = NULL;
					GeeArrayList* _tmp46_;
					gpointer _tmp47_;
					GeeArrayList* _tmp48_;
					Cell* _tmp49_;
					GeeArrayList* _tmp50_;
					Cell* _tmp51_;
#line 143 "../src/board.vala"
					_neighbour_index = _neighbour_index + 1;
#line 143 "../src/board.vala"
					_tmp44_ = _neighbour_index;
#line 143 "../src/board.vala"
					_tmp45_ = _neighbour_size;
#line 143 "../src/board.vala"
					if (!(_tmp44_ < _tmp45_)) {
#line 143 "../src/board.vala"
						break;
#line 1112 "board.c"
					}
#line 143 "../src/board.vala"
					_tmp46_ = _neighbour_list;
#line 143 "../src/board.vala"
					_tmp47_ = gee_abstract_list_get ((GeeAbstractList*) _tmp46_, _neighbour_index);
#line 143 "../src/board.vala"
					neighbour = (Cell*) _tmp47_;
#line 146 "../src/board.vala"
					_tmp48_ = self->closed;
#line 146 "../src/board.vala"
					_tmp49_ = neighbour;
#line 146 "../src/board.vala"
					if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp48_, _tmp49_)) {
#line 148 "../src/board.vala"
						_cell_unref0 (neighbour);
#line 148 "../src/board.vala"
						continue;
#line 1130 "board.c"
					}
#line 152 "../src/board.vala"
					_tmp50_ = self->priv->open;
#line 152 "../src/board.vala"
					_tmp51_ = neighbour;
#line 152 "../src/board.vala"
					if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp50_, _tmp51_)) {
#line 1138 "board.c"
						Cell* _tmp52_;
						Cell* _tmp53_;
						Cell* _tmp54_;
						GeeArrayList* _tmp55_;
						Cell* _tmp56_;
#line 154 "../src/board.vala"
						_tmp52_ = neighbour;
#line 154 "../src/board.vala"
						_tmp53_ = current_cell;
#line 154 "../src/board.vala"
						_tmp54_ = _cell_ref0 (_tmp53_);
#line 154 "../src/board.vala"
						_cell_unref0 (_tmp52_->parent);
#line 154 "../src/board.vala"
						_tmp52_->parent = _tmp54_;
#line 155 "../src/board.vala"
						_tmp55_ = self->priv->open;
#line 155 "../src/board.vala"
						_tmp56_ = neighbour;
#line 155 "../src/board.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp55_, _tmp56_);
#line 1160 "board.c"
					} else {
						Cell* _tmp57_;
						Cell* _tmp58_;
						Cell* _tmp59_;
#line 162 "../src/board.vala"
						_tmp57_ = neighbour;
#line 162 "../src/board.vala"
						_tmp58_ = self->priv->dst;
#line 162 "../src/board.vala"
						_tmp59_ = neighbour;
#line 162 "../src/board.vala"
						if (board_total_cost (self, _tmp57_, _tmp58_, current_cost) < _tmp59_->cost) {
#line 1173 "board.c"
							Cell* _tmp60_;
							Cell* _tmp61_;
							Cell* _tmp62_;
							Cell* _tmp63_;
							Cell* _tmp64_;
							Cell* _tmp65_;
#line 164 "../src/board.vala"
							_tmp60_ = neighbour;
#line 164 "../src/board.vala"
							_tmp61_ = current_cell;
#line 164 "../src/board.vala"
							_tmp62_ = _cell_ref0 (_tmp61_);
#line 164 "../src/board.vala"
							_cell_unref0 (_tmp60_->parent);
#line 164 "../src/board.vala"
							_tmp60_->parent = _tmp62_;
#line 165 "../src/board.vala"
							_tmp63_ = neighbour;
#line 165 "../src/board.vala"
							_tmp64_ = neighbour;
#line 165 "../src/board.vala"
							_tmp65_ = self->priv->dst;
#line 165 "../src/board.vala"
							_tmp63_->cost = board_total_cost (self, _tmp64_, _tmp65_, current_cost);
#line 1198 "board.c"
						}
					}
#line 143 "../src/board.vala"
					_cell_unref0 (neighbour);
#line 1203 "board.c"
				}
			}
		}
	}
#line 171 "../src/board.vala"
	_tmp66_ = self->path;
#line 171 "../src/board.vala"
	_tmp67_ = _g_object_ref0 (_tmp66_);
#line 171 "../src/board.vala"
	result = _tmp67_;
#line 171 "../src/board.vala"
	_g_object_unref0 (neighbours);
#line 171 "../src/board.vala"
	_cell_unref0 (current_cell);
#line 171 "../src/board.vala"
	return result;
#line 1220 "board.c"
}

static gboolean
board_cell_equal (Board* self,
                  Cell* a,
                  Cell* b)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 174 "../src/board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 176 "../src/board.vala"
	if (a != NULL) {
#line 176 "../src/board.vala"
		_tmp1_ = b != NULL;
#line 1237 "board.c"
	} else {
#line 176 "../src/board.vala"
		_tmp1_ = FALSE;
#line 1241 "board.c"
	}
#line 176 "../src/board.vala"
	if (_tmp1_) {
#line 176 "../src/board.vala"
		_tmp0_ = cell_equal (a, b);
#line 1247 "board.c"
	} else {
#line 176 "../src/board.vala"
		_tmp0_ = FALSE;
#line 1251 "board.c"
	}
#line 176 "../src/board.vala"
	result = _tmp0_;
#line 176 "../src/board.vala"
	return result;
#line 1257 "board.c"
}

static void
board_reset_path_search (Board* self)
{
	GeeArrayList* _tmp0_;
	Cell** _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
#line 179 "../src/board.vala"
	g_return_if_fail (self != NULL);
#line 181 "../src/board.vala"
	_tmp0_ = self->path;
#line 181 "../src/board.vala"
	if (_tmp0_ != NULL) {
#line 1273 "board.c"
		GeeArrayList* _tmp1_;
#line 182 "../src/board.vala"
		_tmp1_ = self->path;
#line 182 "../src/board.vala"
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
#line 1279 "board.c"
	} else {
		GeeArrayList* _tmp2_;
#line 184 "../src/board.vala"
		_tmp2_ = gee_array_list_new (TYPE_CELL, (GBoxedCopyFunc) cell_ref, (GDestroyNotify) cell_unref, NULL, NULL, NULL);
#line 184 "../src/board.vala"
		_g_object_unref0 (self->path);
#line 184 "../src/board.vala"
		self->path = _tmp2_;
#line 1288 "board.c"
	}
#line 186 "../src/board.vala"
	_tmp3_ = self->priv->grid;
#line 186 "../src/board.vala"
	_tmp3__length1 = self->priv->grid_length1;
#line 186 "../src/board.vala"
	_tmp3__length2 = self->priv->grid_length2;
#line 1296 "board.c"
	{
		Cell** cell_collection = NULL;
		gint cell_collection_length1 = 0;
		gint cell_collection_length2 = 0;
		gint cell_it = 0;
#line 186 "../src/board.vala"
		cell_collection = _tmp3_;
#line 186 "../src/board.vala"
		cell_collection_length1 = _tmp3__length1 * _tmp3__length2;
#line 186 "../src/board.vala"
		for (cell_it = 0; cell_it < cell_collection_length1; cell_it = cell_it + 1) {
#line 1308 "board.c"
			Cell* _tmp4_;
			Cell* cell = NULL;
#line 186 "../src/board.vala"
			_tmp4_ = _cell_ref0 (cell_collection[cell_it]);
#line 186 "../src/board.vala"
			cell = _tmp4_;
#line 1315 "board.c"
			{
				Cell* _tmp5_;
				Cell* _tmp6_;
#line 188 "../src/board.vala"
				_tmp5_ = cell;
#line 188 "../src/board.vala"
				_cell_unref0 (_tmp5_->parent);
#line 188 "../src/board.vala"
				_tmp5_->parent = NULL;
#line 189 "../src/board.vala"
				_tmp6_ = cell;
#line 189 "../src/board.vala"
				_tmp6_->cost = G_MAXINT;
#line 186 "../src/board.vala"
				_cell_unref0 (cell);
#line 1331 "board.c"
			}
		}
	}
}

static Cell*
board_best_candidate (Board* self,
                      GeeArrayList* neighbours,
                      gint current_cost,
                      Cell* end)
{
	gint lowest_f = 0;
	Cell* best_candidate = NULL;
	Cell* result;
#line 196 "../src/board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 196 "../src/board.vala"
	g_return_val_if_fail (neighbours != NULL, NULL);
#line 196 "../src/board.vala"
	g_return_val_if_fail (end != NULL, NULL);
#line 198 "../src/board.vala"
	lowest_f = G_MAXINT;
#line 199 "../src/board.vala"
	best_candidate = NULL;
#line 1356 "board.c"
	{
		GeeArrayList* _neighbour_list = NULL;
		gint _neighbour_size = 0;
		GeeArrayList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _neighbour_index = 0;
#line 201 "../src/board.vala"
		_neighbour_list = neighbours;
#line 201 "../src/board.vala"
		_tmp0_ = _neighbour_list;
#line 201 "../src/board.vala"
		_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 201 "../src/board.vala"
		_tmp2_ = _tmp1_;
#line 201 "../src/board.vala"
		_neighbour_size = _tmp2_;
#line 201 "../src/board.vala"
		_neighbour_index = -1;
#line 201 "../src/board.vala"
		while (TRUE) {
#line 1378 "board.c"
			gint _tmp3_;
			gint _tmp4_;
			Cell* neighbour = NULL;
			GeeArrayList* _tmp5_;
			gpointer _tmp6_;
			Cell* _tmp7_;
			Cell* _tmp8_;
			Cell* _tmp9_;
#line 201 "../src/board.vala"
			_neighbour_index = _neighbour_index + 1;
#line 201 "../src/board.vala"
			_tmp3_ = _neighbour_index;
#line 201 "../src/board.vala"
			_tmp4_ = _neighbour_size;
#line 201 "../src/board.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 201 "../src/board.vala"
				break;
#line 1397 "board.c"
			}
#line 201 "../src/board.vala"
			_tmp5_ = _neighbour_list;
#line 201 "../src/board.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _neighbour_index);
#line 201 "../src/board.vala"
			neighbour = (Cell*) _tmp6_;
#line 203 "../src/board.vala"
			_tmp7_ = neighbour;
#line 203 "../src/board.vala"
			_tmp8_ = neighbour;
#line 203 "../src/board.vala"
			_tmp7_->cost = board_total_cost (self, _tmp8_, end, current_cost);
#line 205 "../src/board.vala"
			_tmp9_ = neighbour;
#line 205 "../src/board.vala"
			if (_tmp9_->cost < lowest_f) {
#line 1415 "board.c"
				Cell* _tmp10_;
				Cell* _tmp11_;
				Cell* _tmp12_;
#line 207 "../src/board.vala"
				_tmp10_ = neighbour;
#line 207 "../src/board.vala"
				lowest_f = _tmp10_->cost;
#line 208 "../src/board.vala"
				_tmp11_ = neighbour;
#line 208 "../src/board.vala"
				_tmp12_ = _cell_ref0 (_tmp11_);
#line 208 "../src/board.vala"
				_cell_unref0 (best_candidate);
#line 208 "../src/board.vala"
				best_candidate = _tmp12_;
#line 1431 "board.c"
			}
#line 201 "../src/board.vala"
			_cell_unref0 (neighbour);
#line 1435 "board.c"
		}
	}
#line 212 "../src/board.vala"
	result = best_candidate;
#line 212 "../src/board.vala"
	return result;
#line 1442 "board.c"
}

static gint
board_manhattan (Board* self,
                 gint start_x,
                 gint start_y,
                 gint end_x,
                 gint end_y)
{
	gint result;
#line 219 "../src/board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 221 "../src/board.vala"
	result = abs (start_x - end_x) + abs (start_y - end_y);
#line 221 "../src/board.vala"
	return result;
#line 1459 "board.c"
}

static gint
board_total_cost (Board* self,
                  Cell* start,
                  Cell* end,
                  gint current_cost)
{
	gint f = 0;
	gint g = 0;
	gint h = 0;
	gint result;
#line 224 "../src/board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 224 "../src/board.vala"
	g_return_val_if_fail (start != NULL, 0);
#line 224 "../src/board.vala"
	g_return_val_if_fail (end != NULL, 0);
#line 228 "../src/board.vala"
	g = current_cost + 1;
#line 229 "../src/board.vala"
	h = board_manhattan (self, start->row, start->col, end->row, end->col);
#line 230 "../src/board.vala"
	f = g + h;
#line 232 "../src/board.vala"
	result = f;
#line 232 "../src/board.vala"
	return result;
#line 1488 "board.c"
}

gint
board_get_n_rows (Board* self)
{
	gint result;
	Cell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Cell** _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	gint _tmp2_;
#line 29 "../src/board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 30 "../src/board.vala"
	_tmp0_ = self->priv->grid;
#line 30 "../src/board.vala"
	_tmp0__length1 = self->priv->grid_length1;
#line 30 "../src/board.vala"
	_tmp0__length2 = self->priv->grid_length2;
#line 30 "../src/board.vala"
	_vala_assert (_tmp0_ != NULL, "grid != null");
#line 31 "../src/board.vala"
	_tmp1_ = self->priv->grid;
#line 31 "../src/board.vala"
	_tmp1__length1 = self->priv->grid_length1;
#line 31 "../src/board.vala"
	_tmp1__length2 = self->priv->grid_length2;
#line 31 "../src/board.vala"
	_tmp2_ = _tmp1__length1;
#line 31 "../src/board.vala"
	result = _tmp2_;
#line 31 "../src/board.vala"
	return result;
#line 1524 "board.c"
}

gint
board_get_n_cols (Board* self)
{
	gint result;
	Cell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Cell** _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	gint _tmp2_;
#line 36 "../src/board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 37 "../src/board.vala"
	_tmp0_ = self->priv->grid;
#line 37 "../src/board.vala"
	_tmp0__length1 = self->priv->grid_length1;
#line 37 "../src/board.vala"
	_tmp0__length2 = self->priv->grid_length2;
#line 37 "../src/board.vala"
	_vala_assert (_tmp0_ != NULL, "grid != null");
#line 38 "../src/board.vala"
	_tmp1_ = self->priv->grid;
#line 38 "../src/board.vala"
	_tmp1__length1 = self->priv->grid_length1;
#line 38 "../src/board.vala"
	_tmp1__length2 = self->priv->grid_length2;
#line 38 "../src/board.vala"
	_tmp2_ = _tmp1__length2;
#line 38 "../src/board.vala"
	result = _tmp2_;
#line 38 "../src/board.vala"
	return result;
#line 1560 "board.c"
}

static void
value_board_init (GValue* value)
{
#line 24 "../src/board.vala"
	value->data[0].v_pointer = NULL;
#line 1568 "board.c"
}

static void
value_board_free_value (GValue* value)
{
#line 24 "../src/board.vala"
	if (value->data[0].v_pointer) {
#line 24 "../src/board.vala"
		board_unref (value->data[0].v_pointer);
#line 1578 "board.c"
	}
}

static void
value_board_copy_value (const GValue* src_value,
                        GValue* dest_value)
{
#line 24 "../src/board.vala"
	if (src_value->data[0].v_pointer) {
#line 24 "../src/board.vala"
		dest_value->data[0].v_pointer = board_ref (src_value->data[0].v_pointer);
#line 1590 "board.c"
	} else {
#line 24 "../src/board.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1594 "board.c"
	}
}

static gpointer
value_board_peek_pointer (const GValue* value)
{
#line 24 "../src/board.vala"
	return value->data[0].v_pointer;
#line 1603 "board.c"
}

static gchar*
value_board_collect_value (GValue* value,
                           guint n_collect_values,
                           GTypeCValue* collect_values,
                           guint collect_flags)
{
#line 24 "../src/board.vala"
	if (collect_values[0].v_pointer) {
#line 1614 "board.c"
		Board * object;
		object = collect_values[0].v_pointer;
#line 24 "../src/board.vala"
		if (object->parent_instance.g_class == NULL) {
#line 24 "../src/board.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1621 "board.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 24 "../src/board.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1625 "board.c"
		}
#line 24 "../src/board.vala"
		value->data[0].v_pointer = board_ref (object);
#line 1629 "board.c"
	} else {
#line 24 "../src/board.vala"
		value->data[0].v_pointer = NULL;
#line 1633 "board.c"
	}
#line 24 "../src/board.vala"
	return NULL;
#line 1637 "board.c"
}

static gchar*
value_board_lcopy_value (const GValue* value,
                         guint n_collect_values,
                         GTypeCValue* collect_values,
                         guint collect_flags)
{
	Board ** object_p;
	object_p = collect_values[0].v_pointer;
#line 24 "../src/board.vala"
	if (!object_p) {
#line 24 "../src/board.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1652 "board.c"
	}
#line 24 "../src/board.vala"
	if (!value->data[0].v_pointer) {
#line 24 "../src/board.vala"
		*object_p = NULL;
#line 1658 "board.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 24 "../src/board.vala"
		*object_p = value->data[0].v_pointer;
#line 1662 "board.c"
	} else {
#line 24 "../src/board.vala"
		*object_p = board_ref (value->data[0].v_pointer);
#line 1666 "board.c"
	}
#line 24 "../src/board.vala"
	return NULL;
#line 1670 "board.c"
}

GParamSpec*
param_spec_board (const gchar* name,
                  const gchar* nick,
                  const gchar* blurb,
                  GType object_type,
                  GParamFlags flags)
{
	ParamSpecBoard* spec;
#line 24 "../src/board.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_BOARD), NULL);
#line 24 "../src/board.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 24 "../src/board.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 24 "../src/board.vala"
	return G_PARAM_SPEC (spec);
#line 1689 "board.c"
}

gpointer
value_get_board (const GValue* value)
{
#line 24 "../src/board.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BOARD), NULL);
#line 24 "../src/board.vala"
	return value->data[0].v_pointer;
#line 1699 "board.c"
}

void
value_set_board (GValue* value,
                 gpointer v_object)
{
	Board * old;
#line 24 "../src/board.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BOARD));
#line 24 "../src/board.vala"
	old = value->data[0].v_pointer;
#line 24 "../src/board.vala"
	if (v_object) {
#line 24 "../src/board.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BOARD));
#line 24 "../src/board.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "../src/board.vala"
		value->data[0].v_pointer = v_object;
#line 24 "../src/board.vala"
		board_ref (value->data[0].v_pointer);
#line 1721 "board.c"
	} else {
#line 24 "../src/board.vala"
		value->data[0].v_pointer = NULL;
#line 1725 "board.c"
	}
#line 24 "../src/board.vala"
	if (old) {
#line 24 "../src/board.vala"
		board_unref (old);
#line 1731 "board.c"
	}
}

void
value_take_board (GValue* value,
                  gpointer v_object)
{
	Board * old;
#line 24 "../src/board.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BOARD));
#line 24 "../src/board.vala"
	old = value->data[0].v_pointer;
#line 24 "../src/board.vala"
	if (v_object) {
#line 24 "../src/board.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BOARD));
#line 24 "../src/board.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "../src/board.vala"
		value->data[0].v_pointer = v_object;
#line 1752 "board.c"
	} else {
#line 24 "../src/board.vala"
		value->data[0].v_pointer = NULL;
#line 1756 "board.c"
	}
#line 24 "../src/board.vala"
	if (old) {
#line 24 "../src/board.vala"
		board_unref (old);
#line 1762 "board.c"
	}
}

static void
board_class_init (BoardClass * klass,
                  gpointer klass_data)
{
#line 24 "../src/board.vala"
	board_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/board.vala"
	((BoardClass *) klass)->finalize = board_finalize;
#line 24 "../src/board.vala"
	g_type_class_adjust_private_offset (klass, &Board_private_offset);
#line 24 "../src/board.vala"
	board_signals[BOARD_GRID_CHANGED_SIGNAL] = g_signal_new ("grid-changed", TYPE_BOARD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "../src/board.vala"
	board_signals[BOARD_BOARD_CHANGED_SIGNAL] = g_signal_new ("board-changed", TYPE_BOARD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1780 "board.c"
}

static void
board_instance_init (Board * self,
                     gpointer klass)
{
#line 24 "../src/board.vala"
	self->priv = board_get_instance_private (self);
#line 26 "../src/board.vala"
	self->priv->grid = NULL;
#line 26 "../src/board.vala"
	self->priv->grid_length1 = 0;
#line 26 "../src/board.vala"
	self->priv->grid_length2 = 0;
#line 48 "../src/board.vala"
	self->priv->open = NULL;
#line 49 "../src/board.vala"
	self->closed = NULL;
#line 50 "../src/board.vala"
	self->path = NULL;
#line 24 "../src/board.vala"
	self->ref_count = 1;
#line 1803 "board.c"
}

static void
board_finalize (Board * obj)
{
	Board * self;
#line 24 "../src/board.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOARD, Board);
#line 24 "../src/board.vala"
	g_signal_handlers_destroy (self);
#line 26 "../src/board.vala"
	self->priv->grid = (_vala_array_free (self->priv->grid, self->priv->grid_length1 * self->priv->grid_length2, (GDestroyNotify) cell_unref), NULL);
#line 45 "../src/board.vala"
	_cell_unref0 (self->priv->src);
#line 46 "../src/board.vala"
	_cell_unref0 (self->priv->dst);
#line 48 "../src/board.vala"
	_g_object_unref0 (self->priv->open);
#line 49 "../src/board.vala"
	_g_object_unref0 (self->closed);
#line 50 "../src/board.vala"
	_g_object_unref0 (self->path);
#line 1826 "board.c"
}

static GType
board_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_board_init, value_board_free_value, value_board_copy_value, value_board_peek_pointer, "p", value_board_collect_value, "p", value_board_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (BoardClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) board_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Board), 0, (GInstanceInitFunc) board_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType board_type_id;
	board_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Board", &g_define_type_info, &g_define_type_fundamental_info, 0);
	Board_private_offset = g_type_add_instance_private (board_type_id, sizeof (BoardPrivate));
	return board_type_id;
}

GType
board_get_type (void)
{
	static volatile gsize board_type_id__once = 0;
	if (g_once_init_enter (&board_type_id__once)) {
		GType board_type_id;
		board_type_id = board_get_type_once ();
		g_once_init_leave (&board_type_id__once, board_type_id);
	}
	return board_type_id__once;
}

gpointer
board_ref (gpointer instance)
{
	Board * self;
	self = instance;
#line 24 "../src/board.vala"
	g_atomic_int_inc (&self->ref_count);
#line 24 "../src/board.vala"
	return instance;
#line 1862 "board.c"
}

void
board_unref (gpointer instance)
{
	Board * self;
	self = instance;
#line 24 "../src/board.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 24 "../src/board.vala"
		BOARD_GET_CLASS (self)->finalize (self);
#line 24 "../src/board.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1876 "board.c"
	}
}

Cell*
cell_construct (GType object_type,
                gint row,
                gint col,
                Cell* parent,
                Piece* piece)
{
	Cell* self = NULL;
	Cell* _tmp0_;
	Piece* _tmp1_;
#line 244 "../src/board.vala"
	self = (Cell*) g_type_create_instance (object_type);
#line 246 "../src/board.vala"
	self->row = row;
#line 247 "../src/board.vala"
	self->col = col;
#line 248 "../src/board.vala"
	_tmp0_ = _cell_ref0 (parent);
#line 248 "../src/board.vala"
	_cell_unref0 (self->parent);
#line 248 "../src/board.vala"
	self->parent = _tmp0_;
#line 249 "../src/board.vala"
	_tmp1_ = _piece_ref0 (piece);
#line 249 "../src/board.vala"
	_piece_unref0 (self->piece);
#line 249 "../src/board.vala"
	self->piece = _tmp1_;
#line 250 "../src/board.vala"
	self->cost = G_MAXINT;
#line 244 "../src/board.vala"
	return self;
#line 1912 "board.c"
}

Cell*
cell_new (gint row,
          gint col,
          Cell* parent,
          Piece* piece)
{
#line 244 "../src/board.vala"
	return cell_construct (TYPE_CELL, row, col, parent, piece);
#line 1923 "board.c"
}

gboolean
cell_equal (Cell* self,
            Cell* cell)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 253 "../src/board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 253 "../src/board.vala"
	g_return_val_if_fail (cell != NULL, FALSE);
#line 255 "../src/board.vala"
	if (self->row == cell->row) {
#line 255 "../src/board.vala"
		_tmp0_ = self->col == cell->col;
#line 1940 "board.c"
	} else {
#line 255 "../src/board.vala"
		_tmp0_ = FALSE;
#line 1944 "board.c"
	}
#line 255 "../src/board.vala"
	result = _tmp0_;
#line 255 "../src/board.vala"
	return result;
#line 1950 "board.c"
}

static Cell*
cell_get_neighbour (Cell* self,
                    Cell** board,
                    gint board_length1,
                    gint board_length2,
                    Direction dir)
{
	Cell* neighbour = NULL;
	gint row = 0;
	gint col = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	Cell* result;
#line 258 "../src/board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 260 "../src/board.vala"
	neighbour = NULL;
#line 261 "../src/board.vala"
	row = -1;
#line 261 "../src/board.vala"
	col = -1;
#line 263 "../src/board.vala"
	switch (dir) {
#line 263 "../src/board.vala"
		case DIRECTION_RIGHT:
#line 1979 "board.c"
		{
#line 266 "../src/board.vala"
			row = self->row;
#line 267 "../src/board.vala"
			col = self->col + 1;
#line 268 "../src/board.vala"
			break;
#line 1987 "board.c"
		}
#line 263 "../src/board.vala"
		case DIRECTION_LEFT:
#line 1991 "board.c"
		{
#line 270 "../src/board.vala"
			row = self->row;
#line 271 "../src/board.vala"
			col = self->col - 1;
#line 272 "../src/board.vala"
			break;
#line 1999 "board.c"
		}
#line 263 "../src/board.vala"
		case DIRECTION_UP:
#line 2003 "board.c"
		{
#line 274 "../src/board.vala"
			row = self->row - 1;
#line 275 "../src/board.vala"
			col = self->col;
#line 276 "../src/board.vala"
			break;
#line 2011 "board.c"
		}
#line 263 "../src/board.vala"
		case DIRECTION_DOWN:
#line 2015 "board.c"
		{
#line 278 "../src/board.vala"
			row = self->row + 1;
#line 279 "../src/board.vala"
			col = self->col;
#line 280 "../src/board.vala"
			break;
#line 2023 "board.c"
		}
#line 263 "../src/board.vala"
		case DIRECTION_UPPER_LEFT:
#line 2027 "board.c"
		{
#line 282 "../src/board.vala"
			row = self->row - 1;
#line 283 "../src/board.vala"
			col = self->col - 1;
#line 284 "../src/board.vala"
			break;
#line 2035 "board.c"
		}
#line 263 "../src/board.vala"
		case DIRECTION_LOWER_RIGHT:
#line 2039 "board.c"
		{
#line 286 "../src/board.vala"
			row = self->row + 1;
#line 287 "../src/board.vala"
			col = self->col + 1;
#line 288 "../src/board.vala"
			break;
#line 2047 "board.c"
		}
#line 263 "../src/board.vala"
		case DIRECTION_UPPER_RIGHT:
#line 2051 "board.c"
		{
#line 290 "../src/board.vala"
			row = self->row - 1;
#line 291 "../src/board.vala"
			col = self->col + 1;
#line 292 "../src/board.vala"
			break;
#line 2059 "board.c"
		}
#line 263 "../src/board.vala"
		case DIRECTION_LOWER_LEFT:
#line 2063 "board.c"
		{
#line 294 "../src/board.vala"
			row = self->row + 1;
#line 295 "../src/board.vala"
			col = self->col - 1;
#line 296 "../src/board.vala"
			break;
#line 2071 "board.c"
		}
		default:
#line 263 "../src/board.vala"
		break;
#line 2076 "board.c"
	}
#line 299 "../src/board.vala"
	if (row >= 0) {
#line 2080 "board.c"
		gint _tmp3_;
#line 299 "../src/board.vala"
		_tmp3_ = board_length1;
#line 299 "../src/board.vala"
		_tmp2_ = row < _tmp3_;
#line 2086 "board.c"
	} else {
#line 299 "../src/board.vala"
		_tmp2_ = FALSE;
#line 2090 "board.c"
	}
#line 299 "../src/board.vala"
	if (_tmp2_) {
#line 300 "../src/board.vala"
		_tmp1_ = col >= 0;
#line 2096 "board.c"
	} else {
#line 299 "../src/board.vala"
		_tmp1_ = FALSE;
#line 2100 "board.c"
	}
#line 299 "../src/board.vala"
	if (_tmp1_) {
#line 2104 "board.c"
		gint _tmp4_;
#line 300 "../src/board.vala"
		_tmp4_ = board_length2;
#line 300 "../src/board.vala"
		_tmp0_ = col < _tmp4_;
#line 2110 "board.c"
	} else {
#line 299 "../src/board.vala"
		_tmp0_ = FALSE;
#line 2114 "board.c"
	}
#line 299 "../src/board.vala"
	if (_tmp0_) {
#line 2118 "board.c"
		Cell* _tmp5_;
		Cell* _tmp6_;
#line 301 "../src/board.vala"
		_tmp5_ = board[(row * board_length2) + col];
#line 301 "../src/board.vala"
		_tmp6_ = _cell_ref0 (_tmp5_);
#line 301 "../src/board.vala"
		_cell_unref0 (neighbour);
#line 301 "../src/board.vala"
		neighbour = _tmp6_;
#line 2129 "board.c"
	}
#line 303 "../src/board.vala"
	result = neighbour;
#line 303 "../src/board.vala"
	return result;
#line 2135 "board.c"
}

GeeArrayList*
cell_get_neighbours (Cell* self,
                     Cell** board,
                     gint board_length1,
                     gint board_length2)
{
	GeeArrayList* neighbours = NULL;
	GeeArrayList* _tmp0_;
	Cell* right = NULL;
	Cell* left = NULL;
	Cell* up = NULL;
	Cell* down = NULL;
	Cell* _tmp1_;
	gboolean _tmp2_ = FALSE;
	Cell* _tmp3_;
	Cell* _tmp8_;
	gboolean _tmp9_ = FALSE;
	Cell* _tmp10_;
	Cell* _tmp15_;
	gboolean _tmp16_ = FALSE;
	Cell* _tmp17_;
	Cell* _tmp22_;
	gboolean _tmp23_ = FALSE;
	Cell* _tmp24_;
	GeeArrayList* result;
#line 306 "../src/board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 308 "../src/board.vala"
	_tmp0_ = gee_array_list_new (TYPE_CELL, (GBoxedCopyFunc) cell_ref, (GDestroyNotify) cell_unref, NULL, NULL, NULL);
#line 308 "../src/board.vala"
	neighbours = _tmp0_;
#line 309 "../src/board.vala"
	right = NULL;
#line 309 "../src/board.vala"
	left = NULL;
#line 309 "../src/board.vala"
	up = NULL;
#line 309 "../src/board.vala"
	down = NULL;
#line 311 "../src/board.vala"
	_tmp1_ = cell_get_neighbour (self, board, (gint) board_length1, (gint) board_length2, DIRECTION_RIGHT);
#line 311 "../src/board.vala"
	_cell_unref0 (right);
#line 311 "../src/board.vala"
	right = _tmp1_;
#line 312 "../src/board.vala"
	_tmp3_ = right;
#line 312 "../src/board.vala"
	if (_tmp3_ != NULL) {
#line 2187 "board.c"
		Cell* _tmp4_;
		Piece* _tmp5_;
#line 312 "../src/board.vala"
		_tmp4_ = right;
#line 312 "../src/board.vala"
		_tmp5_ = _tmp4_->piece;
#line 312 "../src/board.vala"
		_tmp2_ = _tmp5_ == NULL;
#line 2196 "board.c"
	} else {
#line 312 "../src/board.vala"
		_tmp2_ = FALSE;
#line 2200 "board.c"
	}
#line 312 "../src/board.vala"
	if (_tmp2_) {
#line 2204 "board.c"
		GeeArrayList* _tmp6_;
		Cell* _tmp7_;
#line 313 "../src/board.vala"
		_tmp6_ = neighbours;
#line 313 "../src/board.vala"
		_tmp7_ = right;
#line 313 "../src/board.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, _tmp7_);
#line 2213 "board.c"
	}
#line 315 "../src/board.vala"
	_tmp8_ = cell_get_neighbour (self, board, (gint) board_length1, (gint) board_length2, DIRECTION_LEFT);
#line 315 "../src/board.vala"
	_cell_unref0 (left);
#line 315 "../src/board.vala"
	left = _tmp8_;
#line 316 "../src/board.vala"
	_tmp10_ = left;
#line 316 "../src/board.vala"
	if (_tmp10_ != NULL) {
#line 2225 "board.c"
		Cell* _tmp11_;
		Piece* _tmp12_;
#line 316 "../src/board.vala"
		_tmp11_ = left;
#line 316 "../src/board.vala"
		_tmp12_ = _tmp11_->piece;
#line 316 "../src/board.vala"
		_tmp9_ = _tmp12_ == NULL;
#line 2234 "board.c"
	} else {
#line 316 "../src/board.vala"
		_tmp9_ = FALSE;
#line 2238 "board.c"
	}
#line 316 "../src/board.vala"
	if (_tmp9_) {
#line 2242 "board.c"
		GeeArrayList* _tmp13_;
		Cell* _tmp14_;
#line 317 "../src/board.vala"
		_tmp13_ = neighbours;
#line 317 "../src/board.vala"
		_tmp14_ = left;
#line 317 "../src/board.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp14_);
#line 2251 "board.c"
	}
#line 319 "../src/board.vala"
	_tmp15_ = cell_get_neighbour (self, board, (gint) board_length1, (gint) board_length2, DIRECTION_UP);
#line 319 "../src/board.vala"
	_cell_unref0 (up);
#line 319 "../src/board.vala"
	up = _tmp15_;
#line 320 "../src/board.vala"
	_tmp17_ = up;
#line 320 "../src/board.vala"
	if (_tmp17_ != NULL) {
#line 2263 "board.c"
		Cell* _tmp18_;
		Piece* _tmp19_;
#line 320 "../src/board.vala"
		_tmp18_ = up;
#line 320 "../src/board.vala"
		_tmp19_ = _tmp18_->piece;
#line 320 "../src/board.vala"
		_tmp16_ = _tmp19_ == NULL;
#line 2272 "board.c"
	} else {
#line 320 "../src/board.vala"
		_tmp16_ = FALSE;
#line 2276 "board.c"
	}
#line 320 "../src/board.vala"
	if (_tmp16_) {
#line 2280 "board.c"
		GeeArrayList* _tmp20_;
		Cell* _tmp21_;
#line 321 "../src/board.vala"
		_tmp20_ = neighbours;
#line 321 "../src/board.vala"
		_tmp21_ = up;
#line 321 "../src/board.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
#line 2289 "board.c"
	}
#line 323 "../src/board.vala"
	_tmp22_ = cell_get_neighbour (self, board, (gint) board_length1, (gint) board_length2, DIRECTION_DOWN);
#line 323 "../src/board.vala"
	_cell_unref0 (down);
#line 323 "../src/board.vala"
	down = _tmp22_;
#line 324 "../src/board.vala"
	_tmp24_ = down;
#line 324 "../src/board.vala"
	if (_tmp24_ != NULL) {
#line 2301 "board.c"
		Cell* _tmp25_;
		Piece* _tmp26_;
#line 324 "../src/board.vala"
		_tmp25_ = down;
#line 324 "../src/board.vala"
		_tmp26_ = _tmp25_->piece;
#line 324 "../src/board.vala"
		_tmp23_ = _tmp26_ == NULL;
#line 2310 "board.c"
	} else {
#line 324 "../src/board.vala"
		_tmp23_ = FALSE;
#line 2314 "board.c"
	}
#line 324 "../src/board.vala"
	if (_tmp23_) {
#line 2318 "board.c"
		GeeArrayList* _tmp27_;
		Cell* _tmp28_;
#line 325 "../src/board.vala"
		_tmp27_ = neighbours;
#line 325 "../src/board.vala"
		_tmp28_ = down;
#line 325 "../src/board.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp27_, _tmp28_);
#line 2327 "board.c"
	}
#line 327 "../src/board.vala"
	result = neighbours;
#line 327 "../src/board.vala"
	_cell_unref0 (down);
#line 327 "../src/board.vala"
	_cell_unref0 (up);
#line 327 "../src/board.vala"
	_cell_unref0 (left);
#line 327 "../src/board.vala"
	_cell_unref0 (right);
#line 327 "../src/board.vala"
	return result;
#line 2341 "board.c"
}

static void
cell_get_direction (Cell* self,
                    Cell** board,
                    gint board_length1,
                    gint board_length2,
                    Direction dir,
                    GeeArrayList** list)
{
#line 330 "../src/board.vala"
	g_return_if_fail (self != NULL);
#line 332 "../src/board.vala"
	if ((*list) == NULL) {
#line 2356 "board.c"
		GeeArrayList* _tmp0_;
#line 333 "../src/board.vala"
		_tmp0_ = gee_array_list_new (TYPE_CELL, (GBoxedCopyFunc) cell_ref, (GDestroyNotify) cell_unref, NULL, NULL, NULL);
#line 333 "../src/board.vala"
		_g_object_unref0 (*list);
#line 333 "../src/board.vala"
		*list = _tmp0_;
#line 2364 "board.c"
	}
	{
		Cell* cell = NULL;
		Cell* _tmp1_;
#line 335 "../src/board.vala"
		_tmp1_ = _cell_ref0 (self);
#line 335 "../src/board.vala"
		cell = _tmp1_;
#line 2373 "board.c"
		{
			gboolean _tmp2_ = FALSE;
#line 335 "../src/board.vala"
			_tmp2_ = TRUE;
#line 335 "../src/board.vala"
			while (TRUE) {
#line 2380 "board.c"
				gboolean _tmp5_ = FALSE;
				gboolean _tmp6_ = FALSE;
				Cell* _tmp7_;
				Cell* _tmp13_;
#line 335 "../src/board.vala"
				if (!_tmp2_) {
#line 2387 "board.c"
					Cell* _tmp3_;
					Cell* _tmp4_;
#line 337 "../src/board.vala"
					_tmp3_ = cell;
#line 337 "../src/board.vala"
					_tmp4_ = cell_get_neighbour (_tmp3_, board, (gint) board_length1, (gint) board_length2, dir);
#line 337 "../src/board.vala"
					_cell_unref0 (cell);
#line 337 "../src/board.vala"
					cell = _tmp4_;
#line 2398 "board.c"
				}
#line 335 "../src/board.vala"
				_tmp2_ = FALSE;
#line 336 "../src/board.vala"
				_tmp7_ = cell;
#line 336 "../src/board.vala"
				if (_tmp7_ != NULL) {
#line 2406 "board.c"
					Cell* _tmp8_;
					Piece* _tmp9_;
#line 336 "../src/board.vala"
					_tmp8_ = cell;
#line 336 "../src/board.vala"
					_tmp9_ = _tmp8_->piece;
#line 336 "../src/board.vala"
					_tmp6_ = _tmp9_ != NULL;
#line 2415 "board.c"
				} else {
#line 336 "../src/board.vala"
					_tmp6_ = FALSE;
#line 2419 "board.c"
				}
#line 336 "../src/board.vala"
				if (_tmp6_) {
#line 2423 "board.c"
					Cell* _tmp10_;
					Piece* _tmp11_;
					Piece* _tmp12_;
#line 336 "../src/board.vala"
					_tmp10_ = cell;
#line 336 "../src/board.vala"
					_tmp11_ = _tmp10_->piece;
#line 336 "../src/board.vala"
					_tmp12_ = self->piece;
#line 336 "../src/board.vala"
					_tmp5_ = piece_equal (_tmp11_, _tmp12_);
#line 2435 "board.c"
				} else {
#line 336 "../src/board.vala"
					_tmp5_ = FALSE;
#line 2439 "board.c"
				}
#line 336 "../src/board.vala"
				if (!_tmp5_) {
#line 336 "../src/board.vala"
					break;
#line 2445 "board.c"
				}
#line 339 "../src/board.vala"
				_tmp13_ = cell;
#line 339 "../src/board.vala"
				if (!gee_abstract_collection_contains ((GeeAbstractCollection*) (*list), _tmp13_)) {
#line 2451 "board.c"
					Cell* _tmp14_;
#line 340 "../src/board.vala"
					_tmp14_ = cell;
#line 340 "../src/board.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) (*list), _tmp14_);
#line 2457 "board.c"
				}
			}
		}
#line 335 "../src/board.vala"
		_cell_unref0 (cell);
#line 2463 "board.c"
	}
}

static GeeArrayList*
cell_get_horizontal (Cell* self,
                     Cell** board,
                     gint board_length1,
                     gint board_length2)
{
	GeeArrayList* list = NULL;
	GeeArrayList* result;
#line 344 "../src/board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 346 "../src/board.vala"
	list = NULL;
#line 348 "../src/board.vala"
	cell_get_direction (self, board, (gint) board_length1, (gint) board_length2, DIRECTION_LEFT, &list);
#line 349 "../src/board.vala"
	cell_get_direction (self, board, (gint) board_length1, (gint) board_length2, DIRECTION_RIGHT, &list);
#line 351 "../src/board.vala"
	result = list;
#line 351 "../src/board.vala"
	return result;
#line 2487 "board.c"
}

static GeeArrayList*
cell_get_vertical (Cell* self,
                   Cell** board,
                   gint board_length1,
                   gint board_length2)
{
	GeeArrayList* list = NULL;
	GeeArrayList* result;
#line 354 "../src/board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 356 "../src/board.vala"
	list = NULL;
#line 358 "../src/board.vala"
	cell_get_direction (self, board, (gint) board_length1, (gint) board_length2, DIRECTION_UP, &list);
#line 359 "../src/board.vala"
	cell_get_direction (self, board, (gint) board_length1, (gint) board_length2, DIRECTION_DOWN, &list);
#line 361 "../src/board.vala"
	result = list;
#line 361 "../src/board.vala"
	return result;
#line 2510 "board.c"
}

static GeeArrayList*
cell_get_first_diagonal (Cell* self,
                         Cell** board,
                         gint board_length1,
                         gint board_length2)
{
	GeeArrayList* list = NULL;
	GeeArrayList* result;
#line 364 "../src/board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 366 "../src/board.vala"
	list = NULL;
#line 368 "../src/board.vala"
	cell_get_direction (self, board, (gint) board_length1, (gint) board_length2, DIRECTION_UPPER_LEFT, &list);
#line 369 "../src/board.vala"
	cell_get_direction (self, board, (gint) board_length1, (gint) board_length2, DIRECTION_LOWER_RIGHT, &list);
#line 371 "../src/board.vala"
	result = list;
#line 371 "../src/board.vala"
	return result;
#line 2533 "board.c"
}

static GeeArrayList*
cell_get_second_diagonal (Cell* self,
                          Cell** board,
                          gint board_length1,
                          gint board_length2)
{
	GeeArrayList* list = NULL;
	GeeArrayList* result;
#line 374 "../src/board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 376 "../src/board.vala"
	list = NULL;
#line 378 "../src/board.vala"
	cell_get_direction (self, board, (gint) board_length1, (gint) board_length2, DIRECTION_UPPER_RIGHT, &list);
#line 379 "../src/board.vala"
	cell_get_direction (self, board, (gint) board_length1, (gint) board_length2, DIRECTION_LOWER_LEFT, &list);
#line 381 "../src/board.vala"
	result = list;
#line 381 "../src/board.vala"
	return result;
#line 2556 "board.c"
}

GeeHashSet*
cell_get_all_directions (Cell* self,
                         Cell** board,
                         gint board_length1,
                         gint board_length2)
{
	GeeArrayList* list = NULL;
	GeeHashSet* inactivate = NULL;
	GeeHashSet* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GeeArrayList* _tmp15_;
	GeeArrayList* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	GeeArrayList* _tmp29_;
	GeeArrayList* _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	GeeArrayList* _tmp43_;
	GeeArrayList* _tmp44_;
	gint _tmp45_;
	gint _tmp46_;
	GeeHashSet* result;
#line 384 "../src/board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 387 "../src/board.vala"
	_tmp0_ = gee_hash_set_new (TYPE_CELL, (GBoxedCopyFunc) cell_ref, (GDestroyNotify) cell_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 387 "../src/board.vala"
	inactivate = _tmp0_;
#line 389 "../src/board.vala"
	_tmp1_ = cell_get_horizontal (self, board, (gint) board_length1, (gint) board_length2);
#line 389 "../src/board.vala"
	_g_object_unref0 (list);
#line 389 "../src/board.vala"
	list = _tmp1_;
#line 390 "../src/board.vala"
	_tmp2_ = list;
#line 390 "../src/board.vala"
	_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 390 "../src/board.vala"
	_tmp4_ = _tmp3_;
#line 390 "../src/board.vala"
	if (_tmp4_ >= GAME_N_MATCH) {
#line 2605 "board.c"
		{
			GeeArrayList* _l_list = NULL;
			GeeArrayList* _tmp5_;
			gint _l_size = 0;
			GeeArrayList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _l_index = 0;
#line 392 "../src/board.vala"
			_tmp5_ = list;
#line 392 "../src/board.vala"
			_l_list = _tmp5_;
#line 392 "../src/board.vala"
			_tmp6_ = _l_list;
#line 392 "../src/board.vala"
			_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 392 "../src/board.vala"
			_tmp8_ = _tmp7_;
#line 392 "../src/board.vala"
			_l_size = _tmp8_;
#line 392 "../src/board.vala"
			_l_index = -1;
#line 392 "../src/board.vala"
			while (TRUE) {
#line 2630 "board.c"
				gint _tmp9_;
				gint _tmp10_;
				Cell* l = NULL;
				GeeArrayList* _tmp11_;
				gpointer _tmp12_;
				GeeHashSet* _tmp13_;
				Cell* _tmp14_;
#line 392 "../src/board.vala"
				_l_index = _l_index + 1;
#line 392 "../src/board.vala"
				_tmp9_ = _l_index;
#line 392 "../src/board.vala"
				_tmp10_ = _l_size;
#line 392 "../src/board.vala"
				if (!(_tmp9_ < _tmp10_)) {
#line 392 "../src/board.vala"
					break;
#line 2648 "board.c"
				}
#line 392 "../src/board.vala"
				_tmp11_ = _l_list;
#line 392 "../src/board.vala"
				_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _l_index);
#line 392 "../src/board.vala"
				l = (Cell*) _tmp12_;
#line 393 "../src/board.vala"
				_tmp13_ = inactivate;
#line 393 "../src/board.vala"
				_tmp14_ = l;
#line 393 "../src/board.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp14_);
#line 392 "../src/board.vala"
				_cell_unref0 (l);
#line 2664 "board.c"
			}
		}
	}
#line 396 "../src/board.vala"
	_tmp15_ = cell_get_vertical (self, board, (gint) board_length1, (gint) board_length2);
#line 396 "../src/board.vala"
	_g_object_unref0 (list);
#line 396 "../src/board.vala"
	list = _tmp15_;
#line 397 "../src/board.vala"
	_tmp16_ = list;
#line 397 "../src/board.vala"
	_tmp17_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp16_);
#line 397 "../src/board.vala"
	_tmp18_ = _tmp17_;
#line 397 "../src/board.vala"
	if (_tmp18_ >= GAME_N_MATCH) {
#line 2682 "board.c"
		{
			GeeArrayList* _l_list = NULL;
			GeeArrayList* _tmp19_;
			gint _l_size = 0;
			GeeArrayList* _tmp20_;
			gint _tmp21_;
			gint _tmp22_;
			gint _l_index = 0;
#line 399 "../src/board.vala"
			_tmp19_ = list;
#line 399 "../src/board.vala"
			_l_list = _tmp19_;
#line 399 "../src/board.vala"
			_tmp20_ = _l_list;
#line 399 "../src/board.vala"
			_tmp21_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp20_);
#line 399 "../src/board.vala"
			_tmp22_ = _tmp21_;
#line 399 "../src/board.vala"
			_l_size = _tmp22_;
#line 399 "../src/board.vala"
			_l_index = -1;
#line 399 "../src/board.vala"
			while (TRUE) {
#line 2707 "board.c"
				gint _tmp23_;
				gint _tmp24_;
				Cell* l = NULL;
				GeeArrayList* _tmp25_;
				gpointer _tmp26_;
				GeeHashSet* _tmp27_;
				Cell* _tmp28_;
#line 399 "../src/board.vala"
				_l_index = _l_index + 1;
#line 399 "../src/board.vala"
				_tmp23_ = _l_index;
#line 399 "../src/board.vala"
				_tmp24_ = _l_size;
#line 399 "../src/board.vala"
				if (!(_tmp23_ < _tmp24_)) {
#line 399 "../src/board.vala"
					break;
#line 2725 "board.c"
				}
#line 399 "../src/board.vala"
				_tmp25_ = _l_list;
#line 399 "../src/board.vala"
				_tmp26_ = gee_abstract_list_get ((GeeAbstractList*) _tmp25_, _l_index);
#line 399 "../src/board.vala"
				l = (Cell*) _tmp26_;
#line 400 "../src/board.vala"
				_tmp27_ = inactivate;
#line 400 "../src/board.vala"
				_tmp28_ = l;
#line 400 "../src/board.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp27_, _tmp28_);
#line 399 "../src/board.vala"
				_cell_unref0 (l);
#line 2741 "board.c"
			}
		}
	}
#line 403 "../src/board.vala"
	_tmp29_ = cell_get_first_diagonal (self, board, (gint) board_length1, (gint) board_length2);
#line 403 "../src/board.vala"
	_g_object_unref0 (list);
#line 403 "../src/board.vala"
	list = _tmp29_;
#line 404 "../src/board.vala"
	_tmp30_ = list;
#line 404 "../src/board.vala"
	_tmp31_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp30_);
#line 404 "../src/board.vala"
	_tmp32_ = _tmp31_;
#line 404 "../src/board.vala"
	if (_tmp32_ >= GAME_N_MATCH) {
#line 2759 "board.c"
		{
			GeeArrayList* _l_list = NULL;
			GeeArrayList* _tmp33_;
			gint _l_size = 0;
			GeeArrayList* _tmp34_;
			gint _tmp35_;
			gint _tmp36_;
			gint _l_index = 0;
#line 406 "../src/board.vala"
			_tmp33_ = list;
#line 406 "../src/board.vala"
			_l_list = _tmp33_;
#line 406 "../src/board.vala"
			_tmp34_ = _l_list;
#line 406 "../src/board.vala"
			_tmp35_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp34_);
#line 406 "../src/board.vala"
			_tmp36_ = _tmp35_;
#line 406 "../src/board.vala"
			_l_size = _tmp36_;
#line 406 "../src/board.vala"
			_l_index = -1;
#line 406 "../src/board.vala"
			while (TRUE) {
#line 2784 "board.c"
				gint _tmp37_;
				gint _tmp38_;
				Cell* l = NULL;
				GeeArrayList* _tmp39_;
				gpointer _tmp40_;
				GeeHashSet* _tmp41_;
				Cell* _tmp42_;
#line 406 "../src/board.vala"
				_l_index = _l_index + 1;
#line 406 "../src/board.vala"
				_tmp37_ = _l_index;
#line 406 "../src/board.vala"
				_tmp38_ = _l_size;
#line 406 "../src/board.vala"
				if (!(_tmp37_ < _tmp38_)) {
#line 406 "../src/board.vala"
					break;
#line 2802 "board.c"
				}
#line 406 "../src/board.vala"
				_tmp39_ = _l_list;
#line 406 "../src/board.vala"
				_tmp40_ = gee_abstract_list_get ((GeeAbstractList*) _tmp39_, _l_index);
#line 406 "../src/board.vala"
				l = (Cell*) _tmp40_;
#line 407 "../src/board.vala"
				_tmp41_ = inactivate;
#line 407 "../src/board.vala"
				_tmp42_ = l;
#line 407 "../src/board.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp41_, _tmp42_);
#line 406 "../src/board.vala"
				_cell_unref0 (l);
#line 2818 "board.c"
			}
		}
	}
#line 410 "../src/board.vala"
	_tmp43_ = cell_get_second_diagonal (self, board, (gint) board_length1, (gint) board_length2);
#line 410 "../src/board.vala"
	_g_object_unref0 (list);
#line 410 "../src/board.vala"
	list = _tmp43_;
#line 411 "../src/board.vala"
	_tmp44_ = list;
#line 411 "../src/board.vala"
	_tmp45_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp44_);
#line 411 "../src/board.vala"
	_tmp46_ = _tmp45_;
#line 411 "../src/board.vala"
	if (_tmp46_ >= GAME_N_MATCH) {
#line 2836 "board.c"
		{
			GeeArrayList* _l_list = NULL;
			GeeArrayList* _tmp47_;
			gint _l_size = 0;
			GeeArrayList* _tmp48_;
			gint _tmp49_;
			gint _tmp50_;
			gint _l_index = 0;
#line 413 "../src/board.vala"
			_tmp47_ = list;
#line 413 "../src/board.vala"
			_l_list = _tmp47_;
#line 413 "../src/board.vala"
			_tmp48_ = _l_list;
#line 413 "../src/board.vala"
			_tmp49_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp48_);
#line 413 "../src/board.vala"
			_tmp50_ = _tmp49_;
#line 413 "../src/board.vala"
			_l_size = _tmp50_;
#line 413 "../src/board.vala"
			_l_index = -1;
#line 413 "../src/board.vala"
			while (TRUE) {
#line 2861 "board.c"
				gint _tmp51_;
				gint _tmp52_;
				Cell* l = NULL;
				GeeArrayList* _tmp53_;
				gpointer _tmp54_;
				GeeHashSet* _tmp55_;
				Cell* _tmp56_;
#line 413 "../src/board.vala"
				_l_index = _l_index + 1;
#line 413 "../src/board.vala"
				_tmp51_ = _l_index;
#line 413 "../src/board.vala"
				_tmp52_ = _l_size;
#line 413 "../src/board.vala"
				if (!(_tmp51_ < _tmp52_)) {
#line 413 "../src/board.vala"
					break;
#line 2879 "board.c"
				}
#line 413 "../src/board.vala"
				_tmp53_ = _l_list;
#line 413 "../src/board.vala"
				_tmp54_ = gee_abstract_list_get ((GeeAbstractList*) _tmp53_, _l_index);
#line 413 "../src/board.vala"
				l = (Cell*) _tmp54_;
#line 414 "../src/board.vala"
				_tmp55_ = inactivate;
#line 414 "../src/board.vala"
				_tmp56_ = l;
#line 414 "../src/board.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp55_, _tmp56_);
#line 413 "../src/board.vala"
				_cell_unref0 (l);
#line 2895 "board.c"
			}
		}
	}
#line 417 "../src/board.vala"
	result = inactivate;
#line 417 "../src/board.vala"
	_g_object_unref0 (list);
#line 417 "../src/board.vala"
	return result;
#line 2905 "board.c"
}

static void
value_cell_init (GValue* value)
{
#line 236 "../src/board.vala"
	value->data[0].v_pointer = NULL;
#line 2913 "board.c"
}

static void
value_cell_free_value (GValue* value)
{
#line 236 "../src/board.vala"
	if (value->data[0].v_pointer) {
#line 236 "../src/board.vala"
		cell_unref (value->data[0].v_pointer);
#line 2923 "board.c"
	}
}

static void
value_cell_copy_value (const GValue* src_value,
                       GValue* dest_value)
{
#line 236 "../src/board.vala"
	if (src_value->data[0].v_pointer) {
#line 236 "../src/board.vala"
		dest_value->data[0].v_pointer = cell_ref (src_value->data[0].v_pointer);
#line 2935 "board.c"
	} else {
#line 236 "../src/board.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2939 "board.c"
	}
}

static gpointer
value_cell_peek_pointer (const GValue* value)
{
#line 236 "../src/board.vala"
	return value->data[0].v_pointer;
#line 2948 "board.c"
}

static gchar*
value_cell_collect_value (GValue* value,
                          guint n_collect_values,
                          GTypeCValue* collect_values,
                          guint collect_flags)
{
#line 236 "../src/board.vala"
	if (collect_values[0].v_pointer) {
#line 2959 "board.c"
		Cell * object;
		object = collect_values[0].v_pointer;
#line 236 "../src/board.vala"
		if (object->parent_instance.g_class == NULL) {
#line 236 "../src/board.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2966 "board.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 236 "../src/board.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2970 "board.c"
		}
#line 236 "../src/board.vala"
		value->data[0].v_pointer = cell_ref (object);
#line 2974 "board.c"
	} else {
#line 236 "../src/board.vala"
		value->data[0].v_pointer = NULL;
#line 2978 "board.c"
	}
#line 236 "../src/board.vala"
	return NULL;
#line 2982 "board.c"
}

static gchar*
value_cell_lcopy_value (const GValue* value,
                        guint n_collect_values,
                        GTypeCValue* collect_values,
                        guint collect_flags)
{
	Cell ** object_p;
	object_p = collect_values[0].v_pointer;
#line 236 "../src/board.vala"
	if (!object_p) {
#line 236 "../src/board.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2997 "board.c"
	}
#line 236 "../src/board.vala"
	if (!value->data[0].v_pointer) {
#line 236 "../src/board.vala"
		*object_p = NULL;
#line 3003 "board.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 236 "../src/board.vala"
		*object_p = value->data[0].v_pointer;
#line 3007 "board.c"
	} else {
#line 236 "../src/board.vala"
		*object_p = cell_ref (value->data[0].v_pointer);
#line 3011 "board.c"
	}
#line 236 "../src/board.vala"
	return NULL;
#line 3015 "board.c"
}

GParamSpec*
param_spec_cell (const gchar* name,
                 const gchar* nick,
                 const gchar* blurb,
                 GType object_type,
                 GParamFlags flags)
{
	ParamSpecCell* spec;
#line 236 "../src/board.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_CELL), NULL);
#line 236 "../src/board.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 236 "../src/board.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 236 "../src/board.vala"
	return G_PARAM_SPEC (spec);
#line 3034 "board.c"
}

gpointer
value_get_cell (const GValue* value)
{
#line 236 "../src/board.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CELL), NULL);
#line 236 "../src/board.vala"
	return value->data[0].v_pointer;
#line 3044 "board.c"
}

void
value_set_cell (GValue* value,
                gpointer v_object)
{
	Cell * old;
#line 236 "../src/board.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CELL));
#line 236 "../src/board.vala"
	old = value->data[0].v_pointer;
#line 236 "../src/board.vala"
	if (v_object) {
#line 236 "../src/board.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_CELL));
#line 236 "../src/board.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 236 "../src/board.vala"
		value->data[0].v_pointer = v_object;
#line 236 "../src/board.vala"
		cell_ref (value->data[0].v_pointer);
#line 3066 "board.c"
	} else {
#line 236 "../src/board.vala"
		value->data[0].v_pointer = NULL;
#line 3070 "board.c"
	}
#line 236 "../src/board.vala"
	if (old) {
#line 236 "../src/board.vala"
		cell_unref (old);
#line 3076 "board.c"
	}
}

void
value_take_cell (GValue* value,
                 gpointer v_object)
{
	Cell * old;
#line 236 "../src/board.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CELL));
#line 236 "../src/board.vala"
	old = value->data[0].v_pointer;
#line 236 "../src/board.vala"
	if (v_object) {
#line 236 "../src/board.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_CELL));
#line 236 "../src/board.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 236 "../src/board.vala"
		value->data[0].v_pointer = v_object;
#line 3097 "board.c"
	} else {
#line 236 "../src/board.vala"
		value->data[0].v_pointer = NULL;
#line 3101 "board.c"
	}
#line 236 "../src/board.vala"
	if (old) {
#line 236 "../src/board.vala"
		cell_unref (old);
#line 3107 "board.c"
	}
}

static void
cell_class_init (CellClass * klass,
                 gpointer klass_data)
{
#line 236 "../src/board.vala"
	cell_parent_class = g_type_class_peek_parent (klass);
#line 236 "../src/board.vala"
	((CellClass *) klass)->finalize = cell_finalize;
#line 3119 "board.c"
}

static void
cell_instance_init (Cell * self,
                    gpointer klass)
{
#line 236 "../src/board.vala"
	self->ref_count = 1;
#line 3128 "board.c"
}

static void
cell_finalize (Cell * obj)
{
	Cell * self;
#line 236 "../src/board.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CELL, Cell);
#line 236 "../src/board.vala"
	g_signal_handlers_destroy (self);
#line 240 "../src/board.vala"
	_cell_unref0 (self->parent);
#line 241 "../src/board.vala"
	_piece_unref0 (self->piece);
#line 3143 "board.c"
}

static GType
cell_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_cell_init, value_cell_free_value, value_cell_copy_value, value_cell_peek_pointer, "p", value_cell_collect_value, "p", value_cell_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (CellClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cell_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Cell), 0, (GInstanceInitFunc) cell_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType cell_type_id;
	cell_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Cell", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return cell_type_id;
}

GType
cell_get_type (void)
{
	static volatile gsize cell_type_id__once = 0;
	if (g_once_init_enter (&cell_type_id__once)) {
		GType cell_type_id;
		cell_type_id = cell_get_type_once ();
		g_once_init_leave (&cell_type_id__once, cell_type_id);
	}
	return cell_type_id__once;
}

gpointer
cell_ref (gpointer instance)
{
	Cell * self;
	self = instance;
#line 236 "../src/board.vala"
	g_atomic_int_inc (&self->ref_count);
#line 236 "../src/board.vala"
	return instance;
#line 3178 "board.c"
}

void
cell_unref (gpointer instance)
{
	Cell * self;
	self = instance;
#line 236 "../src/board.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 236 "../src/board.vala"
		CELL_GET_CLASS (self)->finalize (self);
#line 236 "../src/board.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3192 "board.c"
	}
}

static GType
direction_get_type_once (void)
{
	static const GEnumValue values[] = {{DIRECTION_RIGHT, "DIRECTION_RIGHT", "right"}, {DIRECTION_LEFT, "DIRECTION_LEFT", "left"}, {DIRECTION_UP, "DIRECTION_UP", "up"}, {DIRECTION_DOWN, "DIRECTION_DOWN", "down"}, {DIRECTION_UPPER_RIGHT, "DIRECTION_UPPER_RIGHT", "upper-right"}, {DIRECTION_LOWER_LEFT, "DIRECTION_LOWER_LEFT", "lower-left"}, {DIRECTION_UPPER_LEFT, "DIRECTION_UPPER_LEFT", "upper-left"}, {DIRECTION_LOWER_RIGHT, "DIRECTION_LOWER_RIGHT", "lower-right"}, {0, NULL, NULL}};
	GType direction_type_id;
	direction_type_id = g_enum_register_static ("Direction", values);
	return direction_type_id;
}

GType
direction_get_type (void)
{
	static volatile gsize direction_type_id__once = 0;
	if (g_once_init_enter (&direction_type_id__once)) {
		GType direction_type_id;
		direction_type_id = direction_get_type_once ();
		g_once_init_leave (&direction_type_id__once, direction_type_id);
	}
	return direction_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

