/* theme-renderer.c generated by valac 0.56.3, the Vala compiler
 * generated from theme-renderer.vala, do not modify */

/*
 * Color lines for GNOME
 * Copyright © 1999 Free Software Foundation
 * Authors: Robert Szokovacs <szo@szo.hu>
 *          Szabolcs Ban <shooby@gnome.hu>
 *          Karuna Grewal <karunagrewal98@gmail.com>
 *          Ruxandra Simion <ruxandra.simion93@gmail.com>
 * Copyright © 2007 Christian Persch
 *
 * This game is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <https://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <librsvg/rsvg.h>
#include <cairo-gobject.h>
#include <gobject/gvaluecollector.h>

#define THEME_RENDERER_DEFAULT_SPRITE_SIZE 20
#define FIVE_OR_MORE_APP_KEY_THEME "ball-theme"
#define GAME_N_TYPES 7
#define GAME_N_ANIMATIONS 4
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_THEME_RENDERER (theme_renderer_get_type ())
#define THEME_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME_RENDERER, ThemeRenderer))
#define THEME_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME_RENDERER, ThemeRendererClass))
#define IS_THEME_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME_RENDERER))
#define IS_THEME_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME_RENDERER))
#define THEME_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME_RENDERER, ThemeRendererClass))

typedef struct _ThemeRenderer ThemeRenderer;
typedef struct _ThemeRendererClass ThemeRendererClass;
typedef struct _ThemeRendererPrivate ThemeRendererPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
typedef struct _ParamSpecThemeRenderer ParamSpecThemeRenderer;
enum  {
	THEME_RENDERER_THEME_CHANGED_SIGNAL,
	THEME_RENDERER_NUM_SIGNALS
};
static guint theme_renderer_signals[THEME_RENDERER_NUM_SIGNALS] = {0};

struct _ThemeRenderer {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ThemeRendererPrivate * priv;
};

struct _ThemeRendererClass {
	GTypeClass parent_class;
	void (*finalize) (ThemeRenderer *self);
};

struct _ThemeRendererPrivate {
	GSettings* settings;
	gint sprite_size;
	gfloat sprite_sheet_width;
	gfloat sprite_sheet_height;
	gfloat theme_sprite_size;
	gchar* theme_name;
	RsvgHandle* theme;
	cairo_pattern_t* tile_pattern;
	cairo_t* cr_preview;
	gboolean is_theme_changed;
};

struct _ParamSpecThemeRenderer {
	GParamSpec parent_instance;
};

static gint ThemeRenderer_private_offset;
static gpointer theme_renderer_parent_class = NULL;

VALA_EXTERN gpointer theme_renderer_ref (gpointer instance);
VALA_EXTERN void theme_renderer_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_theme_renderer (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_theme_renderer (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_theme_renderer (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_theme_renderer (const GValue* value);
VALA_EXTERN GType theme_renderer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThemeRenderer, theme_renderer_unref)
VALA_EXTERN ThemeRenderer* theme_renderer_new (GSettings* settings);
VALA_EXTERN ThemeRenderer* theme_renderer_construct (GType object_type,
                                         GSettings* settings);
static void theme_renderer_change_theme_cb (ThemeRenderer* self);
static void _theme_renderer_change_theme_cb_g_settings_changed (GSettings* _sender,
                                                         const gchar* key,
                                                         gpointer self);
static void theme_renderer_load_theme (ThemeRenderer* self,
                                const gchar* theme_file,
                                GError** error);
VALA_EXTERN void theme_renderer_render_sprite (ThemeRenderer* self,
                                   cairo_t* cr,
                                   gint type,
                                   gint animation,
                                   gdouble x,
                                   gdouble y,
                                   gint size);
static void theme_renderer_finalize (ThemeRenderer * obj);
static GType theme_renderer_get_type_once (void);

const gchar* THEME_RENDERER_themes[3] = {"balls.svg", "shapes.svg", "tango.svg"};

static inline gpointer
theme_renderer_get_instance_private (ThemeRenderer* self)
{
	return G_STRUCT_MEMBER_P (self, ThemeRenderer_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 50 "../src/theme-renderer.vala"
	return self ? g_object_ref (self) : NULL;
#line 154 "theme-renderer.c"
}

static void
_theme_renderer_change_theme_cb_g_settings_changed (GSettings* _sender,
                                                    const gchar* key,
                                                    gpointer self)
{
#line 52 "../src/theme-renderer.vala"
	theme_renderer_change_theme_cb ((ThemeRenderer*) self);
#line 164 "theme-renderer.c"
}

ThemeRenderer*
theme_renderer_construct (GType object_type,
                          GSettings* settings)
{
	ThemeRenderer* self = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
#line 48 "../src/theme-renderer.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 48 "../src/theme-renderer.vala"
	self = (ThemeRenderer*) g_type_create_instance (object_type);
#line 50 "../src/theme-renderer.vala"
	_tmp0_ = _g_object_ref0 (settings);
#line 50 "../src/theme-renderer.vala"
	_g_object_unref0 (self->priv->settings);
#line 50 "../src/theme-renderer.vala"
	self->priv->settings = _tmp0_;
#line 52 "../src/theme-renderer.vala"
	_tmp1_ = g_strconcat ("changed::", FIVE_OR_MORE_APP_KEY_THEME, NULL);
#line 52 "../src/theme-renderer.vala"
	g_signal_connect (settings, _tmp1_, (GCallback) _theme_renderer_change_theme_cb_g_settings_changed, self);
#line 52 "../src/theme-renderer.vala"
	_g_free0 (_tmp1_);
#line 53 "../src/theme-renderer.vala"
	theme_renderer_change_theme_cb (self);
#line 55 "../src/theme-renderer.vala"
	self->priv->is_theme_changed = FALSE;
#line 48 "../src/theme-renderer.vala"
	return self;
#line 196 "theme-renderer.c"
}

ThemeRenderer*
theme_renderer_new (GSettings* settings)
{
#line 48 "../src/theme-renderer.vala"
	return theme_renderer_construct (TYPE_THEME_RENDERER, settings);
#line 204 "theme-renderer.c"
}

static void
theme_renderer_change_theme_cb (ThemeRenderer* self)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* theme_file = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 58 "../src/theme-renderer.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/theme-renderer.vala"
	_tmp0_ = self->priv->settings;
#line 60 "../src/theme-renderer.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, FIVE_OR_MORE_APP_KEY_THEME);
#line 60 "../src/theme-renderer.vala"
	_g_free0 (self->priv->theme_name);
#line 60 "../src/theme-renderer.vala"
	self->priv->theme_name = _tmp1_;
#line 61 "../src/theme-renderer.vala"
	_tmp2_ = self->priv->theme_name;
#line 61 "../src/theme-renderer.vala"
	_tmp3_ = g_build_filename (DATA_DIRECTORY, "themes", _tmp2_, NULL);
#line 61 "../src/theme-renderer.vala"
	theme_file = _tmp3_;
#line 232 "theme-renderer.c"
	{
		const gchar* _tmp4_;
#line 65 "../src/theme-renderer.vala"
		_tmp4_ = theme_file;
#line 65 "../src/theme-renderer.vala"
		theme_renderer_load_theme (self, _tmp4_, &_inner_error0_);
#line 65 "../src/theme-renderer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 241 "theme-renderer.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GSettings* _tmp5_;
		GVariant* _tmp6_;
		GVariant* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 63 "../src/theme-renderer.vala"
		g_clear_error (&_inner_error0_);
#line 69 "../src/theme-renderer.vala"
		_tmp5_ = self->priv->settings;
#line 69 "../src/theme-renderer.vala"
		_tmp6_ = g_settings_get_default_value (_tmp5_, FIVE_OR_MORE_APP_KEY_THEME);
#line 69 "../src/theme-renderer.vala"
		_tmp7_ = _tmp6_;
#line 69 "../src/theme-renderer.vala"
		_tmp8_ = g_variant_get_string (_tmp7_, NULL);
#line 69 "../src/theme-renderer.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 69 "../src/theme-renderer.vala"
		_g_free0 (self->priv->theme_name);
#line 69 "../src/theme-renderer.vala"
		self->priv->theme_name = _tmp9_;
#line 69 "../src/theme-renderer.vala"
		_g_variant_unref0 (_tmp7_);
#line 70 "../src/theme-renderer.vala"
		_tmp10_ = self->priv->theme_name;
#line 70 "../src/theme-renderer.vala"
		_tmp11_ = g_build_filename (DATA_DIRECTORY, "themes", _tmp10_, NULL);
#line 70 "../src/theme-renderer.vala"
		_g_free0 (theme_file);
#line 70 "../src/theme-renderer.vala"
		theme_file = _tmp11_;
#line 281 "theme-renderer.c"
		{
			const gchar* _tmp12_;
#line 74 "../src/theme-renderer.vala"
			_tmp12_ = theme_file;
#line 74 "../src/theme-renderer.vala"
			theme_renderer_load_theme (self, _tmp12_, &_inner_error0_);
#line 74 "../src/theme-renderer.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 290 "theme-renderer.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 72 "../src/theme-renderer.vala"
			g_clear_error (&_inner_error0_);
#line 78 "../src/theme-renderer.vala"
			g_warning ("theme-renderer.vala:78: Unable to load default theme\n");
#line 301 "theme-renderer.c"
		}
		__finally1:
#line 72 "../src/theme-renderer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 72 "../src/theme-renderer.vala"
			_g_free0 (theme_file);
#line 72 "../src/theme-renderer.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 72 "../src/theme-renderer.vala"
			g_clear_error (&_inner_error0_);
#line 72 "../src/theme-renderer.vala"
			return;
#line 314 "theme-renderer.c"
		}
#line 81 "../src/theme-renderer.vala"
		g_warning ("theme-renderer.vala:81: Unable to load chosen theme\n");
#line 318 "theme-renderer.c"
	}
	__finally0:
#line 63 "../src/theme-renderer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 63 "../src/theme-renderer.vala"
		_g_free0 (theme_file);
#line 63 "../src/theme-renderer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 63 "../src/theme-renderer.vala"
		g_clear_error (&_inner_error0_);
#line 63 "../src/theme-renderer.vala"
		return;
#line 331 "theme-renderer.c"
	}
#line 58 "../src/theme-renderer.vala"
	_g_free0 (theme_file);
#line 335 "theme-renderer.c"
}

static void
theme_renderer_load_theme (ThemeRenderer* self,
                           const gchar* theme_file,
                           GError** error)
{
	RsvgHandle* _tmp0_ = NULL;
	RsvgHandle* _tmp1_;
	RsvgHandle* _tmp2_;
	RsvgDimensionData dimensions = {0};
	RsvgHandle* _tmp3_;
	RsvgDimensionData _tmp4_ = {0};
	RsvgDimensionData _tmp5_;
	RsvgDimensionData _tmp6_;
	GError* _inner_error0_ = NULL;
#line 85 "../src/theme-renderer.vala"
	g_return_if_fail (self != NULL);
#line 85 "../src/theme-renderer.vala"
	g_return_if_fail (theme_file != NULL);
#line 87 "../src/theme-renderer.vala"
	_tmp1_ = rsvg_handle_new_from_file (theme_file, &_inner_error0_);
#line 87 "../src/theme-renderer.vala"
	_tmp0_ = _tmp1_;
#line 87 "../src/theme-renderer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 87 "../src/theme-renderer.vala"
		g_propagate_error (error, _inner_error0_);
#line 87 "../src/theme-renderer.vala"
		return;
#line 366 "theme-renderer.c"
	}
#line 87 "../src/theme-renderer.vala"
	_tmp2_ = _tmp0_;
#line 87 "../src/theme-renderer.vala"
	_tmp0_ = NULL;
#line 87 "../src/theme-renderer.vala"
	_g_object_unref0 (self->priv->theme);
#line 87 "../src/theme-renderer.vala"
	self->priv->theme = _tmp2_;
#line 88 "../src/theme-renderer.vala"
	_tmp3_ = self->priv->theme;
#line 88 "../src/theme-renderer.vala"
	rsvg_handle_get_dimensions (_tmp3_, &_tmp4_);
#line 88 "../src/theme-renderer.vala"
	dimensions = _tmp4_;
#line 89 "../src/theme-renderer.vala"
	_tmp5_ = dimensions;
#line 89 "../src/theme-renderer.vala"
	self->priv->sprite_sheet_width = (gfloat) _tmp5_.width;
#line 90 "../src/theme-renderer.vala"
	_tmp6_ = dimensions;
#line 90 "../src/theme-renderer.vala"
	self->priv->sprite_sheet_height = (gfloat) _tmp6_.height;
#line 91 "../src/theme-renderer.vala"
	self->priv->theme_sprite_size = self->priv->sprite_sheet_height / GAME_N_TYPES;
#line 93 "../src/theme-renderer.vala"
	g_signal_emit (self, theme_renderer_signals[THEME_RENDERER_THEME_CHANGED_SIGNAL], 0);
#line 94 "../src/theme-renderer.vala"
	self->priv->is_theme_changed = TRUE;
#line 85 "../src/theme-renderer.vala"
	_g_object_unref0 (_tmp0_);
#line 398 "theme-renderer.c"
}

void
theme_renderer_render_sprite (ThemeRenderer* self,
                              cairo_t* cr,
                              gint type,
                              gint animation,
                              gdouble x,
                              gdouble y,
                              gint size)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	cairo_pattern_t* _tmp13_;
	gint texture_x = 0;
	gint texture_y = 0;
	cairo_matrix_t m = {0};
	cairo_pattern_t* _tmp14_;
	cairo_matrix_t _tmp15_;
#line 97 "../src/theme-renderer.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/theme-renderer.vala"
	g_return_if_fail (cr != NULL);
#line 99 "../src/theme-renderer.vala"
	if (self->priv->is_theme_changed) {
#line 99 "../src/theme-renderer.vala"
		_tmp1_ = TRUE;
#line 426 "theme-renderer.c"
	} else {
		cairo_pattern_t* _tmp2_;
#line 99 "../src/theme-renderer.vala"
		_tmp2_ = self->priv->tile_pattern;
#line 99 "../src/theme-renderer.vala"
		_tmp1_ = _tmp2_ == NULL;
#line 433 "theme-renderer.c"
	}
#line 99 "../src/theme-renderer.vala"
	if (_tmp1_) {
#line 99 "../src/theme-renderer.vala"
		_tmp0_ = TRUE;
#line 439 "theme-renderer.c"
	} else {
#line 99 "../src/theme-renderer.vala"
		_tmp0_ = self->priv->sprite_size != size;
#line 443 "theme-renderer.c"
	}
#line 99 "../src/theme-renderer.vala"
	if (_tmp0_) {
#line 447 "theme-renderer.c"
		cairo_surface_t* preview_surface = NULL;
		cairo_surface_t* _tmp3_;
		cairo_surface_t* _tmp4_;
		cairo_surface_t* _tmp5_;
		cairo_t* _tmp6_;
		cairo_matrix_t matrix = {0};
		cairo_t* _tmp7_;
		cairo_matrix_t _tmp8_;
		RsvgHandle* _tmp9_;
		cairo_t* _tmp10_;
		cairo_surface_t* _tmp11_;
		cairo_pattern_t* _tmp12_;
#line 101 "../src/theme-renderer.vala"
		self->priv->is_theme_changed = FALSE;
#line 102 "../src/theme-renderer.vala"
		self->priv->sprite_size = size;
#line 104 "../src/theme-renderer.vala"
		_tmp3_ = cairo_get_target (cr);
#line 104 "../src/theme-renderer.vala"
		_tmp4_ = cairo_surface_create_similar (_tmp3_, CAIRO_CONTENT_COLOR_ALPHA, GAME_N_ANIMATIONS * self->priv->sprite_size, GAME_N_TYPES * self->priv->sprite_size);
#line 104 "../src/theme-renderer.vala"
		preview_surface = _tmp4_;
#line 108 "../src/theme-renderer.vala"
		_tmp5_ = preview_surface;
#line 108 "../src/theme-renderer.vala"
		_tmp6_ = cairo_create (_tmp5_);
#line 108 "../src/theme-renderer.vala"
		_cairo_destroy0 (self->priv->cr_preview);
#line 108 "../src/theme-renderer.vala"
		self->priv->cr_preview = _tmp6_;
#line 110 "../src/theme-renderer.vala"
		cairo_matrix_init_identity (&matrix);
#line 111 "../src/theme-renderer.vala"
		cairo_matrix_scale (&matrix, (gdouble) (((self->priv->sprite_sheet_width / self->priv->theme_sprite_size) * self->priv->sprite_size) / self->priv->sprite_sheet_width), (gdouble) ((GAME_N_TYPES * self->priv->sprite_size) / self->priv->sprite_sheet_height));
#line 113 "../src/theme-renderer.vala"
		_tmp7_ = self->priv->cr_preview;
#line 113 "../src/theme-renderer.vala"
		_tmp8_ = matrix;
#line 113 "../src/theme-renderer.vala"
		cairo_set_matrix (_tmp7_, &_tmp8_);
#line 115 "../src/theme-renderer.vala"
		_tmp9_ = self->priv->theme;
#line 115 "../src/theme-renderer.vala"
		_tmp10_ = self->priv->cr_preview;
#line 115 "../src/theme-renderer.vala"
		rsvg_handle_render_cairo (_tmp9_, _tmp10_);
#line 117 "../src/theme-renderer.vala"
		_tmp11_ = preview_surface;
#line 117 "../src/theme-renderer.vala"
		_tmp12_ = cairo_pattern_create_for_surface (_tmp11_);
#line 117 "../src/theme-renderer.vala"
		_cairo_pattern_destroy0 (self->priv->tile_pattern);
#line 117 "../src/theme-renderer.vala"
		self->priv->tile_pattern = _tmp12_;
#line 99 "../src/theme-renderer.vala"
		_cairo_surface_destroy0 (preview_surface);
#line 504 "theme-renderer.c"
	}
#line 120 "../src/theme-renderer.vala"
	_tmp13_ = self->priv->tile_pattern;
#line 120 "../src/theme-renderer.vala"
	cairo_set_source (cr, _tmp13_);
#line 122 "../src/theme-renderer.vala"
	texture_x = self->priv->sprite_size * animation;
#line 123 "../src/theme-renderer.vala"
	texture_y = self->priv->sprite_size * type;
#line 125 "../src/theme-renderer.vala"
	cairo_matrix_init_identity (&m);
#line 126 "../src/theme-renderer.vala"
	cairo_matrix_translate (&m, texture_x - x, texture_y - y);
#line 127 "../src/theme-renderer.vala"
	_tmp14_ = self->priv->tile_pattern;
#line 127 "../src/theme-renderer.vala"
	_tmp15_ = m;
#line 127 "../src/theme-renderer.vala"
	cairo_pattern_set_matrix (_tmp14_, &_tmp15_);
#line 129 "../src/theme-renderer.vala"
	cairo_rectangle (cr, x, y, (gdouble) self->priv->sprite_size, (gdouble) self->priv->sprite_size);
#line 130 "../src/theme-renderer.vala"
	cairo_fill (cr);
#line 528 "theme-renderer.c"
}

static void
value_theme_renderer_init (GValue* value)
{
#line 24 "../src/theme-renderer.vala"
	value->data[0].v_pointer = NULL;
#line 536 "theme-renderer.c"
}

static void
value_theme_renderer_free_value (GValue* value)
{
#line 24 "../src/theme-renderer.vala"
	if (value->data[0].v_pointer) {
#line 24 "../src/theme-renderer.vala"
		theme_renderer_unref (value->data[0].v_pointer);
#line 546 "theme-renderer.c"
	}
}

static void
value_theme_renderer_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
#line 24 "../src/theme-renderer.vala"
	if (src_value->data[0].v_pointer) {
#line 24 "../src/theme-renderer.vala"
		dest_value->data[0].v_pointer = theme_renderer_ref (src_value->data[0].v_pointer);
#line 558 "theme-renderer.c"
	} else {
#line 24 "../src/theme-renderer.vala"
		dest_value->data[0].v_pointer = NULL;
#line 562 "theme-renderer.c"
	}
}

static gpointer
value_theme_renderer_peek_pointer (const GValue* value)
{
#line 24 "../src/theme-renderer.vala"
	return value->data[0].v_pointer;
#line 571 "theme-renderer.c"
}

static gchar*
value_theme_renderer_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
#line 24 "../src/theme-renderer.vala"
	if (collect_values[0].v_pointer) {
#line 582 "theme-renderer.c"
		ThemeRenderer * object;
		object = collect_values[0].v_pointer;
#line 24 "../src/theme-renderer.vala"
		if (object->parent_instance.g_class == NULL) {
#line 24 "../src/theme-renderer.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 589 "theme-renderer.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 24 "../src/theme-renderer.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 593 "theme-renderer.c"
		}
#line 24 "../src/theme-renderer.vala"
		value->data[0].v_pointer = theme_renderer_ref (object);
#line 597 "theme-renderer.c"
	} else {
#line 24 "../src/theme-renderer.vala"
		value->data[0].v_pointer = NULL;
#line 601 "theme-renderer.c"
	}
#line 24 "../src/theme-renderer.vala"
	return NULL;
#line 605 "theme-renderer.c"
}

static gchar*
value_theme_renderer_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	ThemeRenderer ** object_p;
	object_p = collect_values[0].v_pointer;
#line 24 "../src/theme-renderer.vala"
	if (!object_p) {
#line 24 "../src/theme-renderer.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 620 "theme-renderer.c"
	}
#line 24 "../src/theme-renderer.vala"
	if (!value->data[0].v_pointer) {
#line 24 "../src/theme-renderer.vala"
		*object_p = NULL;
#line 626 "theme-renderer.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 24 "../src/theme-renderer.vala"
		*object_p = value->data[0].v_pointer;
#line 630 "theme-renderer.c"
	} else {
#line 24 "../src/theme-renderer.vala"
		*object_p = theme_renderer_ref (value->data[0].v_pointer);
#line 634 "theme-renderer.c"
	}
#line 24 "../src/theme-renderer.vala"
	return NULL;
#line 638 "theme-renderer.c"
}

GParamSpec*
param_spec_theme_renderer (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	ParamSpecThemeRenderer* spec;
#line 24 "../src/theme-renderer.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_THEME_RENDERER), NULL);
#line 24 "../src/theme-renderer.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 24 "../src/theme-renderer.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 24 "../src/theme-renderer.vala"
	return G_PARAM_SPEC (spec);
#line 657 "theme-renderer.c"
}

gpointer
value_get_theme_renderer (const GValue* value)
{
#line 24 "../src/theme-renderer.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_THEME_RENDERER), NULL);
#line 24 "../src/theme-renderer.vala"
	return value->data[0].v_pointer;
#line 667 "theme-renderer.c"
}

void
value_set_theme_renderer (GValue* value,
                          gpointer v_object)
{
	ThemeRenderer * old;
#line 24 "../src/theme-renderer.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_THEME_RENDERER));
#line 24 "../src/theme-renderer.vala"
	old = value->data[0].v_pointer;
#line 24 "../src/theme-renderer.vala"
	if (v_object) {
#line 24 "../src/theme-renderer.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_THEME_RENDERER));
#line 24 "../src/theme-renderer.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "../src/theme-renderer.vala"
		value->data[0].v_pointer = v_object;
#line 24 "../src/theme-renderer.vala"
		theme_renderer_ref (value->data[0].v_pointer);
#line 689 "theme-renderer.c"
	} else {
#line 24 "../src/theme-renderer.vala"
		value->data[0].v_pointer = NULL;
#line 693 "theme-renderer.c"
	}
#line 24 "../src/theme-renderer.vala"
	if (old) {
#line 24 "../src/theme-renderer.vala"
		theme_renderer_unref (old);
#line 699 "theme-renderer.c"
	}
}

void
value_take_theme_renderer (GValue* value,
                           gpointer v_object)
{
	ThemeRenderer * old;
#line 24 "../src/theme-renderer.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_THEME_RENDERER));
#line 24 "../src/theme-renderer.vala"
	old = value->data[0].v_pointer;
#line 24 "../src/theme-renderer.vala"
	if (v_object) {
#line 24 "../src/theme-renderer.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_THEME_RENDERER));
#line 24 "../src/theme-renderer.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "../src/theme-renderer.vala"
		value->data[0].v_pointer = v_object;
#line 720 "theme-renderer.c"
	} else {
#line 24 "../src/theme-renderer.vala"
		value->data[0].v_pointer = NULL;
#line 724 "theme-renderer.c"
	}
#line 24 "../src/theme-renderer.vala"
	if (old) {
#line 24 "../src/theme-renderer.vala"
		theme_renderer_unref (old);
#line 730 "theme-renderer.c"
	}
}

static void
theme_renderer_class_init (ThemeRendererClass * klass,
                           gpointer klass_data)
{
#line 24 "../src/theme-renderer.vala"
	theme_renderer_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/theme-renderer.vala"
	((ThemeRendererClass *) klass)->finalize = theme_renderer_finalize;
#line 24 "../src/theme-renderer.vala"
	g_type_class_adjust_private_offset (klass, &ThemeRenderer_private_offset);
#line 24 "../src/theme-renderer.vala"
	theme_renderer_signals[THEME_RENDERER_THEME_CHANGED_SIGNAL] = g_signal_new ("theme-changed", TYPE_THEME_RENDERER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 746 "theme-renderer.c"
}

static void
theme_renderer_instance_init (ThemeRenderer * self,
                              gpointer klass)
{
#line 24 "../src/theme-renderer.vala"
	self->priv = theme_renderer_get_instance_private (self);
#line 29 "../src/theme-renderer.vala"
	self->priv->sprite_size = THEME_RENDERER_DEFAULT_SPRITE_SIZE;
#line 35 "../src/theme-renderer.vala"
	self->priv->theme = NULL;
#line 42 "../src/theme-renderer.vala"
	self->priv->tile_pattern = NULL;
#line 24 "../src/theme-renderer.vala"
	self->ref_count = 1;
#line 763 "theme-renderer.c"
}

static void
theme_renderer_finalize (ThemeRenderer * obj)
{
	ThemeRenderer * self;
#line 24 "../src/theme-renderer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_THEME_RENDERER, ThemeRenderer);
#line 24 "../src/theme-renderer.vala"
	g_signal_handlers_destroy (self);
#line 26 "../src/theme-renderer.vala"
	_g_object_unref0 (self->priv->settings);
#line 34 "../src/theme-renderer.vala"
	_g_free0 (self->priv->theme_name);
#line 35 "../src/theme-renderer.vala"
	_g_object_unref0 (self->priv->theme);
#line 42 "../src/theme-renderer.vala"
	_cairo_pattern_destroy0 (self->priv->tile_pattern);
#line 43 "../src/theme-renderer.vala"
	_cairo_destroy0 (self->priv->cr_preview);
#line 784 "theme-renderer.c"
}

static GType
theme_renderer_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_theme_renderer_init, value_theme_renderer_free_value, value_theme_renderer_copy_value, value_theme_renderer_peek_pointer, "p", value_theme_renderer_collect_value, "p", value_theme_renderer_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ThemeRendererClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) theme_renderer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ThemeRenderer), 0, (GInstanceInitFunc) theme_renderer_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType theme_renderer_type_id;
	theme_renderer_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ThemeRenderer", &g_define_type_info, &g_define_type_fundamental_info, 0);
	ThemeRenderer_private_offset = g_type_add_instance_private (theme_renderer_type_id, sizeof (ThemeRendererPrivate));
	return theme_renderer_type_id;
}

GType
theme_renderer_get_type (void)
{
	static volatile gsize theme_renderer_type_id__once = 0;
	if (g_once_init_enter (&theme_renderer_type_id__once)) {
		GType theme_renderer_type_id;
		theme_renderer_type_id = theme_renderer_get_type_once ();
		g_once_init_leave (&theme_renderer_type_id__once, theme_renderer_type_id);
	}
	return theme_renderer_type_id__once;
}

gpointer
theme_renderer_ref (gpointer instance)
{
	ThemeRenderer * self;
	self = instance;
#line 24 "../src/theme-renderer.vala"
	g_atomic_int_inc (&self->ref_count);
#line 24 "../src/theme-renderer.vala"
	return instance;
#line 820 "theme-renderer.c"
}

void
theme_renderer_unref (gpointer instance)
{
	ThemeRenderer * self;
	self = instance;
#line 24 "../src/theme-renderer.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 24 "../src/theme-renderer.vala"
		THEME_RENDERER_GET_CLASS (self)->finalize (self);
#line 24 "../src/theme-renderer.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 834 "theme-renderer.c"
	}
}

